## centreon-broker 18.10.0

=== build/CMakeLists.txt ===
##
## Copyright 2009-2018 Centreon
##
## Licensed under the Apache License, Version 2.0 (the "License");
## you may not use this file except in compliance with the License.
## You may obtain a copy of the License at
##
##     http://www.apache.org/licenses/LICENSE-2.0
##
## Unless required by applicable law or agreed to in writing, software
## distributed under the License is distributed on an "AS IS" BASIS,
## WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
## See the License for the specific language governing permissions and
## limitations under the License.
##
## For more information : contact@centreon.com
##

#
# Global settings.
#

# Set necessary settings.
cmake_minimum_required(VERSION 2.8)
project("Centreon Broker" C CXX)
set(PROJECT_SOURCE_DIR "${PROJECT_SOURCE_DIR}/..")
set(INC_DIR "${PROJECT_SOURCE_DIR}/core/inc")
include_directories("${INC_DIR}")
set(INC_DIR "${PROJECT_SOURCE_DIR}/core/inc/com/centreon/broker")
set(SRC_DIR "${PROJECT_SOURCE_DIR}/core/src")
set(TEST_DIR "${PROJECT_SOURCE_DIR}/core/test")

# Version.
set(CENTREON_BROKER_MAJOR 18)
set(CENTREON_BROKER_MINOR 10)
set(CENTREON_BROKER_PATCH 0)
set(CENTREON_BROKER_VERSION "${CENTREON_BROKER_MAJOR}.${CENTREON_BROKER_MINOR}.${CENTREON_BROKER_PATCH}")
add_definitions(-DCENTREON_BROKER_VERSION=\"${CENTREON_BROKER_VERSION}\")
configure_file(
  "${INC_DIR}/version.hh.in"
  "${INC_DIR}/version.hh"
  "@ONLY"
)

#
# Check and/or find required components.
#

# Find Qt.
find_package(Qt4 4.7.4 COMPONENTS QtCore QtNetwork QtSql QtXml REQUIRED)

# Find zlib.
find_package(ZLIB REQUIRED)

include(${QT_USE_FILE})
set(QT_VERSION "${QT_VERSION_MAJOR}.${QT_VERSION_MINOR}.${QT_VERSION_PATCH}")
if (("${QT_VERSION}" VERSION_EQUAL "4.7.0")
    OR ("${QT_VERSION}" VERSION_EQUAL "4.7.1"))
  message(WARNING "Qt versions 4.7.0 and 4.7.1 contain a bug that might prevent Centreon Broker from working properly.")
endif ()

#
# Get distributions name
#
if (CMAKE_SYSTEM_NAME STREQUAL "Linux")
  message(STATUS "Attempting to determine OS distributor.")
  execute_process(COMMAND "lsb_release" "--short" "--id"
    RESULT_VARIABLE RETCODE
    OUTPUT_VARIABLE OS_DISTRIBUTOR
    ERROR_QUIET)
  if (RETCODE EQUAL 0)
    string(REGEX REPLACE "\n$" "" OS_DISTRIBUTOR "${OS_DISTRIBUTOR}")
  else ()
    message(WARNING "lsb_release in not installed")
    set(OS_DISTRIBUTOR "${CMAKE_SYSTEM_NAME}")
  endif ()
elseif ()
  set(OS_DISTRIBUTOR "${CMAKE_SYSTEM_NAME}")
endif ()


#
# Options.
#

# Main directory.
if (WITH_PREFIX)
  set(CMAKE_INSTALL_PREFIX "${WITH_PREFIX}")
endif ()

# Executable directory.
if (WITH_PREFIX_BIN)
  set(PREFIX_BIN "${WITH_PREFIX_BIN}")
else ()
  set(PREFIX_BIN "${CMAKE_INSTALL_PREFIX}/bin")
endif ()

# Configuration directory.
if (WITH_PREFIX_CONF)
  set(PREFIX_CONF "${WITH_PREFIX_CONF}")
else ()
  set(PREFIX_CONF "${CMAKE_INSTALL_PREFIX}/etc")
endif ()

# Library directory.
if (WITH_PREFIX_LIB)
  set(PREFIX_LIB "${WITH_PREFIX_LIB}")
else ()
  set(PREFIX_LIB "${CMAKE_INSTALL_PREFIX}/lib")
endif ()

# Modules directory.
if (WITH_PREFIX_MODULES)
  set(PREFIX_MODULES "${WITH_PREFIX_MODULES}")
else ()
  set(PREFIX_MODULES "${PREFIX_LIB}/centreon-broker")
endif ()

# var directory.
if (WITH_PREFIX_VAR)
  set(PREFIX_VAR "${WITH_PREFIX_VAR}")
else ()
  set(PREFIX_VAR "${CMAKE_INSTALL_PREFIX}/var")
endif ()

# Development headers directory.
if (WITH_PREFIX_INC)
  set(PREFIX_INC "${WITH_PREFIX_INC}")
else ()
  set(PREFIX_INC "${CMAKE_INSTALL_PREFIX}/include/centreon-broker")
endif ()

# User.
if (WITH_USER)
  set(USER "${WITH_USER}")
else ()
  set(USER "root")
endif ()

# Group.
if (WITH_GROUP)
  set(GROUP "${WITH_GROUP}")
else ()
  set(GROUP "root")
endif ()

# Code coverage on unit tests
option(WITH_COVERAGE "Add code coverage on unit tests." OFF)
if (WITH_TESTING AND WITH_COVERAGE)
  set(CMAKE_BUILD_TYPE "Debug")
  include("CodeCoverage.cmake")
  APPEND_COVERAGE_COMPILER_FLAGS()
endif()

# Set startup script to auto if not defined.
if (NOT WITH_STARTUP_SCRIPT)
  set(WITH_STARTUP_SCRIPT "auto")
endif ()

# Check which startup script to use.
if (WITH_STARTUP_SCRIPT STREQUAL "auto")
  if (CMAKE_SYSTEM_NAME STREQUAL "Linux")
    set(WITH_STARTUP_SCRIPT "sysv")
  else ()
    message(STATUS "Centreon Broker does not provide startup script for ${CMAKE_SYSTEM_NAME}.")
    set(WITH_STARTUP_SCRIPT "no")
  endif ()
endif ()

# Startup dir.
if (WITH_STARTUP_SCRIPT STREQUAL "sysv"
    OR WITH_STARTUP_SCRIPT STREQUAL "systemd")
  # Set destination directory.
  if (WITH_STARTUP_DIR)
    set(STARTUP_DIR "${WITH_STARTUP_DIR}")
  else ()
    set(STARTUP_DIR "/etc/init.d")
  endif ()
endif ()

# Configure files.
if (WITH_DAEMONS)
  if (WITH_STARTUP_SCRIPT STREQUAL "systemd")
    configure_file("${PROJECT_SOURCE_DIR}/script/systemd/cbd.service.in"
     "${PROJECT_SOURCE_DIR}/script/cbd.service"
      @ONLY)
    install(FILES "${PROJECT_SOURCE_DIR}/script/cbd.service"
      DESTINATION "${STARTUP_DIR}")
  elseif (OS_DISTRIBUTOR STREQUAL "CentOS" OR OS_DISTRIBUTOR STREQUAL "RedHat")
    configure_file("${PROJECT_SOURCE_DIR}/script/redhat/cbd.init.d.in"
      "${PROJECT_SOURCE_DIR}/script/cbd.init"
      @ONLY)
  elseif (OS_DISTRIBUTOR STREQUAL "Debian" OR OS_DISTRIBUTOR STREQUAL "Ubuntu")
    configure_file("${PROJECT_SOURCE_DIR}/script/debian/cbd.init.d.in"
      "${PROJECT_SOURCE_DIR}/script/cbd.init"
      @ONLY)
    configure_file("${PROJECT_SOURCE_DIR}/script/debian/cbd.default.in"
      "${PROJECT_SOURCE_DIR}/script/cbd.default"
      @ONLY)
    install(FILES "${PROJECT_SOURCE_DIR}/script/cbd.default"
      DESTINATION "/etc/default"
      RENAME "cbd")
  else ()
    configure_file("${PROJECT_SOURCE_DIR}/script/other/cbd.init.d.in"
      "${PROJECT_SOURCE_DIR}/script/cbd.init"
      @ONLY)
  endif ()

  foreach (DAEMON_NAME IN LISTS WITH_DAEMONS)
    set(DAEMONS_CONFIGURATION
      "${DAEMONS_CONFIGURATION}  <cbd>\n  <name>${DAEMON_NAME}</name>\n    <configuration_file>${PREFIX_CONF}/${DAEMON_NAME}.xml</configuration_file>\n    <run>1</run>\n    <reload>1</reload>\n  </cbd>\n")
  endforeach ()

  configure_file("${PROJECT_SOURCE_DIR}/script/watchdog.xml.in"
    "${PROJECT_SOURCE_DIR}/script/watchdog.xml"
    @ONLY)
  install(FILES "${PROJECT_SOURCE_DIR}/script/watchdog.xml"
    DESTINATION "${PREFIX_CONF}")
  if (WITH_STARTUP_SCRIPT STREQUAL "sysv")
    install(PROGRAMS "${PROJECT_SOURCE_DIR}/script/cbd.init"
      DESTINATION "${STARTUP_DIR}"
      RENAME "cbd")
  endif ()
endif ()

if (WITH_CONFIG_FILES)
  configure_file("${PROJECT_SOURCE_DIR}/config/poller-module.xml.in"
    "${PROJECT_SOURCE_DIR}/config/poller-module.xml"
    @ONLY)
  configure_file("${PROJECT_SOURCE_DIR}/config/central-broker.xml.in"
    "${PROJECT_SOURCE_DIR}/config/central-broker.xml"
    @ONLY)
  configure_file("${PROJECT_SOURCE_DIR}/config/central-rrd.xml.in"
    "${PROJECT_SOURCE_DIR}/config/central-rrd.xml"
    @ONLY)
  configure_file("${PROJECT_SOURCE_DIR}/config/cbmod.cfg.in"
    "${PROJECT_SOURCE_DIR}/config/cbmod.cfg"
    @ONLY)

  install(FILES "${PROJECT_SOURCE_DIR}/config/poller-module.xml"
    DESTINATION "${PREFIX_CONF}")
  install(FILES "${PROJECT_SOURCE_DIR}/config/central-rrd.xml"
    DESTINATION "${PREFIX_CONF}")
  install(FILES "${PROJECT_SOURCE_DIR}/config/central-broker.xml"
    DESTINATION "${PREFIX_CONF}")
endif ()

# Monitoring engine (for testing).
if (WITH_MONITORING_ENGINE)
  set(MONITORING_ENGINE_ADDITIONAL "")
  set(MONITORING_ENGINE "${WITH_MONITORING_ENGINE}")
  if (WITH_MONITORING_ENGINE_MODULES)
    foreach (MODULE IN LISTS WITH_MONITORING_ENGINE_MODULES)
      set(MONITORING_ENGINE_ADDITIONAL
          "${MONITORING_ENGINE_ADDITIONAL}broker_module=${MODULE}\\n")
    endforeach ()
  endif ()
  if (WITH_MONITORING_ENGINE_INTERVAL_LENGTH)
    set(MONITORING_ENGINE_INTERVAL_LENGTH "${WITH_MONITORING_ENGINE_INTERVAL_LENGTH}")
  else ()
    set(MONITORING_ENGINE_INTERVAL_LENGTH 1)
  endif ()
endif ()

# DB parameters.
if (WITH_DB_TYPE)
  set(DB_TYPE "${WITH_DB_TYPE}")
  if (WITH_DB_HOST)
    set(DB_HOST "${WITH_DB_HOST}")
  else ()
    set(DB_HOST "localhost")
  endif ()
  if (WITH_DB_PORT)
    set(DB_PORT "${WITH_DB_PORT}")
  else ()
    set(DB_PORT "3306")
  endif ()
  if (WITH_DB_USER)
    set(DB_USER "${WITH_DB_USER}")
  else ()
    message(FATAL_ERROR "WITH_DB_USER is not specified.")
  endif ()
  if (WITH_DB_PASSWORD)
    set(DB_PASSWORD "${WITH_DB_PASSWORD}")
  else ()
    set(DB_PASSWORD "")
  endif ()
endif ()

# Broker vars
configure_file(
  "${INC_DIR}/vars.hh.in"
  "${INC_DIR}/vars.hh"
  "@ONLY"
)


#
# Targets.
#

# Some files must be processed by Qt's moc.
qt4_wrap_cpp(QT_WRAPPED_SOURCES
  "${INC_DIR}/logging/backend.hh"
  "${INC_DIR}/logging/manager.hh"
  "${INC_DIR}/processing/thread.hh"
)

include_directories("${INC_DIR}/json/yajl/")

set(YAJL_SOURCES
  # Sources.
  "${SRC_DIR}/json/yajl/yajl_version.c"
  "${SRC_DIR}/json/yajl/yajl_tree.c"
  "${SRC_DIR}/json/yajl/yajl_parser.c"
  "${SRC_DIR}/json/yajl/yajl_lex.c"
  "${SRC_DIR}/json/yajl/yajl_gen.c"
  "${SRC_DIR}/json/yajl/yajl_encode.c"
  "${SRC_DIR}/json/yajl/yajl_buf.c"
  "${SRC_DIR}/json/yajl/yajl_alloc.c"
  "${SRC_DIR}/json/yajl/yajl.c"
  # Includes.
  "${SRC_DIR}/json/yajl/api/yajl_version.h"
  "${SRC_DIR}/json/yajl/yajl_parser.h"
  "${SRC_DIR}/json/yajl/yajl_lex.h"
  "${SRC_DIR}/json/yajl/yajl_encode.h"
  "${SRC_DIR}/json/yajl/yajl_bytestack.h"
  "${SRC_DIR}/json/yajl/yajl_buf.h"
  "${SRC_DIR}/json/yajl/yajl_alloc.h"
  "${SRC_DIR}/json/yajl/api/yajl_tree.h"
  "${SRC_DIR}/json/yajl/api/yajl_parse.h"
  "${SRC_DIR}/json/yajl/api/yajl_gen.h"
  "${SRC_DIR}/json/yajl/api/yajl_common.h"
  "${INC_DIR}/json/yajl/yajl/yajl_version.h"
  "${INC_DIR}/json/yajl/yajl/yajl_tree.h"
  "${INC_DIR}/json/yajl/yajl/yajl_parse.h"
  "${INC_DIR}/json/yajl/yajl/yajl_gen.h"
  "${INC_DIR}/json/yajl/yajl/yajl_common.h"
  )

# Core library.
set(LIBROKER_SOURCES
  # Sources.
  ${YAJL_SOURCES}
  "${SRC_DIR}/bbdo/acceptor.cc"
  "${SRC_DIR}/bbdo/ack.cc"
  "${SRC_DIR}/bbdo/connector.cc"
  "${SRC_DIR}/bbdo/factory.cc"
  "${SRC_DIR}/bbdo/input.cc"
  "${SRC_DIR}/bbdo/input_buffer.cc"
  "${SRC_DIR}/bbdo/internal.cc"
  "${SRC_DIR}/bbdo/output.cc"
  "${SRC_DIR}/bbdo/stream.cc"
  "${SRC_DIR}/bbdo/version_response.cc"
  "${SRC_DIR}/ceof/ceof_writer.cc"
  "${SRC_DIR}/ceof/ceof_parser.cc"
  "${SRC_DIR}/ceof/ceof_iterator.cc"
  "${SRC_DIR}/ceof/ceof_token.cc"
  "${SRC_DIR}/ceof/ceof_serializer.cc"
  "${SRC_DIR}/ceof/ceof_deserializer.cc"
  "${SRC_DIR}/compression/factory.cc"
  "${SRC_DIR}/compression/internal.cc"
  "${SRC_DIR}/compression/opener.cc"
  "${SRC_DIR}/compression/stack_array.cc"
  "${SRC_DIR}/compression/stream.cc"
  "${SRC_DIR}/compression/zlib.cc"
  "${SRC_DIR}/config/applier/endpoint.cc"
  "${SRC_DIR}/config/applier/modules.cc"
  "${SRC_DIR}/config/applier/state.cc"
  "${SRC_DIR}/config/endpoint.cc"
  "${SRC_DIR}/config/logger.cc"
  "${SRC_DIR}/config/parser.cc"
  "${SRC_DIR}/config/state.cc"
  "${SRC_DIR}/database.cc"
  "${SRC_DIR}/database_config.cc"
  "${SRC_DIR}/database_preparator.cc"
  "${SRC_DIR}/database_query.cc"
  "${SRC_DIR}/exceptions/config.cc"
  "${SRC_DIR}/exceptions/corruption.cc"
  "${SRC_DIR}/exceptions/interrupt.cc"
  "${SRC_DIR}/exceptions/msg.cc"
  "${SRC_DIR}/exceptions/shutdown.cc"
  "${SRC_DIR}/exceptions/timeout.cc"
  "${SRC_DIR}/extcmd/command_client.cc"
  "${SRC_DIR}/extcmd/command_parser.cc"
  "${SRC_DIR}/extcmd/command_listener.cc"
  "${SRC_DIR}/extcmd/command_request.cc"
  "${SRC_DIR}/extcmd/command_result.cc"
  "${SRC_DIR}/extcmd/command_server.cc"
  "${SRC_DIR}/extcmd/factory.cc"
  "${SRC_DIR}/extcmd/internal.cc"
  "${SRC_DIR}/extcmd/json_command_parser.cc"
  "${SRC_DIR}/extcmd/plaintext_command_parser.cc"
  "${SRC_DIR}/extcmd/server_socket.cc"
  "${SRC_DIR}/file/cfile.cc"
  "${SRC_DIR}/file/directory_event.cc"
  "${SRC_DIR}/file/directory_watcher.cc"
  "${SRC_DIR}/file/factory.cc"
  "${SRC_DIR}/file/fifo.cc"
  "${SRC_DIR}/file/fs_browser.cc"
  "${SRC_DIR}/file/fs_file.cc"
  "${SRC_DIR}/file/internal.cc"
  "${SRC_DIR}/file/opener.cc"

=== doc/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
PAPER         =
BUILDDIR      = _build

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .
# the i18n builder cannot share the environment and doctrees with the others
I18NSPHINXOPTS  = $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .

.PHONY: help clean html dirhtml singlehtml pickle json htmlhelp qthelp devhelp epub latex latexpdf text man changes linkcheck doctest gettext

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  dirhtml    to make HTML files named index.html in directories"
	@echo "  singlehtml to make a single large HTML file"
	@echo "  pickle     to make pickle files"
	@echo "  json       to make JSON files"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  qthelp     to make HTML files and a qthelp project"
	@echo "  devhelp    to make HTML files and a Devhelp project"
	@echo "  epub       to make an epub"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
	@echo "  text       to make text files"
	@echo "  man        to make manual pages"
	@echo "  texinfo    to make Texinfo files"
	@echo "  info       to make Texinfo files and run them through makeinfo"
	@echo "  gettext    to make PO message catalogs"
	@echo "  changes    to make an overview of all changed/added/deprecated items"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"

clean:
	-rm -rf $(BUILDDIR)/*

html:
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

dirhtml:
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

singlehtml:
	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
	@echo
	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."

pickle:
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json:
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp:
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

qthelp:
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/CentreonBroker.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/CentreonBroker.qhc"

devhelp:
	$(SPHINXBUILD) -b devhelp $(ALLSPHINXOPTS) $(BUILDDIR)/devhelp
	@echo
	@echo "Build finished."
	@echo "To view the help file:"
	@echo "# mkdir -p $$HOME/.local/share/devhelp/CentreonBroker"
	@echo "# ln -s $(BUILDDIR)/devhelp $$HOME/.local/share/devhelp/CentreonBroker"
	@echo "# devhelp"

epub:
	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
	@echo
	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."

latex:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make' in that directory to run these through (pdf)latex" \
	      "(use \`make latexpdf' here to do that automatically)."

latexpdf:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through pdflatex..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

text:
	$(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
	@echo
	@echo "Build finished. The text files are in $(BUILDDIR)/text."

man:
	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
	@echo
	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."

texinfo:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo
	@echo "Build finished. The Texinfo files are in $(BUILDDIR)/texinfo."
	@echo "Run \`make' in that directory to run these through makeinfo" \
	      "(use \`make info' here to do that automatically)."

info:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo "Running Texinfo files through makeinfo..."
	make -C $(BUILDDIR)/texinfo info
	@echo "makeinfo finished; the Info files are in $(BUILDDIR)/texinfo."

gettext:
	$(SPHINXBUILD) -b gettext $(I18NSPHINXOPTS) $(BUILDDIR)/locale
	@echo
	@echo "Build finished. The message catalogs are in $(BUILDDIR)/locale."

changes:
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

=== build/bam/CMakeLists.txt ===
##
## Copyright 2011-2016 Centreon
##
## Licensed under the Apache License, Version 2.0 (the "License");
## you may not use this file except in compliance with the License.
## You may obtain a copy of the License at
##
##     http://www.apache.org/licenses/LICENSE-2.0
##
## Unless required by applicable law or agreed to in writing, software
## distributed under the License is distributed on an "AS IS" BASIS,
## WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
## See the License for the specific language governing permissions and
## limitations under the License.
##
## For more information : contact@centreon.com
##

# Global options.
set(INC_DIR "${PROJECT_SOURCE_DIR}/bam/inc")
set(SRC_DIR "${PROJECT_SOURCE_DIR}/bam/src")
set(TEST_DIR "${PROJECT_SOURCE_DIR}/bam/test")
include_directories("${INC_DIR}")
include_directories("${PROJECT_SOURCE_DIR}/neb/inc")
include_directories("${PROJECT_SOURCE_DIR}/storage/inc")
set(INC_DIR "${INC_DIR}/com/centreon/broker/bam")

# BAM module.
set(BAM "20-bam")
set(BAM "${BAM}" PARENT_SCOPE)
add_library("${BAM}" SHARED
  # Sources.
  "${SRC_DIR}/availability_builder.cc"
  "${SRC_DIR}/availability_thread.cc"
  "${SRC_DIR}/ba.cc"
  "${SRC_DIR}/ba_status.cc"
  "${SRC_DIR}/ba_svc_mapping.cc"
  "${SRC_DIR}/ba_event.cc"
  "${SRC_DIR}/ba_duration_event.cc"
  "${SRC_DIR}/bool_aggregate.cc"
  "${SRC_DIR}/bool_and.cc"
  "${SRC_DIR}/bool_binary_operator.cc"
  "${SRC_DIR}/bool_call.cc"
  "${SRC_DIR}/bool_constant.cc"
  "${SRC_DIR}/bool_equal.cc"
  "${SRC_DIR}/bool_expression.cc"
  "${SRC_DIR}/bool_less_than.cc"
  "${SRC_DIR}/bool_metric.cc"
  "${SRC_DIR}/bool_more_than.cc"
  "${SRC_DIR}/bool_not.cc"
  "${SRC_DIR}/bool_not_equal.cc"
  "${SRC_DIR}/bool_operation.cc"
  "${SRC_DIR}/bool_or.cc"
  "${SRC_DIR}/bool_service.cc"
  "${SRC_DIR}/bool_value.cc"
  "${SRC_DIR}/bool_xor.cc"
  "${SRC_DIR}/computable.cc"
  "${SRC_DIR}/configuration/applier/ba.cc"
  "${SRC_DIR}/configuration/applier/bool_expression.cc"
  "${SRC_DIR}/configuration/applier/kpi.cc"
  "${SRC_DIR}/configuration/applier/meta_service.cc"
  "${SRC_DIR}/configuration/applier/state.cc"
  "${SRC_DIR}/configuration/ba.cc"
  "${SRC_DIR}/configuration/bool_expression.cc"
  "${SRC_DIR}/configuration/kpi.cc"
  "${SRC_DIR}/configuration/meta_service.cc"
  "${SRC_DIR}/configuration/reader.cc"
  "${SRC_DIR}/configuration/reader_exception.cc"
  "${SRC_DIR}/configuration/reader_v2.cc"
  "${SRC_DIR}/configuration/state.cc"
  "${SRC_DIR}/connector.cc"
  "${SRC_DIR}/dimension_ba_event.cc"
  "${SRC_DIR}/dimension_kpi_event.cc"
  "${SRC_DIR}/dimension_ba_bv_relation_event.cc"
  "${SRC_DIR}/dimension_bv_event.cc"
  "${SRC_DIR}/dimension_timeperiod.cc"
  "${SRC_DIR}/dimension_timeperiod_exception.cc"
  "${SRC_DIR}/dimension_timeperiod_exclusion.cc"
  "${SRC_DIR}/dimension_ba_timeperiod_relation.cc"
  "${SRC_DIR}/dimension_truncate_table_signal.cc"
  "${SRC_DIR}/exp_builder.cc"
  "${SRC_DIR}/exp_parser.cc"
  "${SRC_DIR}/exp_tokenizer.cc"
  "${SRC_DIR}/factory.cc"
  "${SRC_DIR}/event_cache_visitor.cc"
  "${SRC_DIR}/hst_svc_mapping.cc"
  "${SRC_DIR}/impact_values.cc"
  "${SRC_DIR}/inherited_downtime.cc"
  "${SRC_DIR}/kpi.cc"
  "${SRC_DIR}/kpi_ba.cc"
  "${SRC_DIR}/kpi_boolexp.cc"
  "${SRC_DIR}/kpi_event.cc"
  "${SRC_DIR}/kpi_meta.cc"
  "${SRC_DIR}/kpi_service.cc"
  "${SRC_DIR}/kpi_status.cc"
  "${SRC_DIR}/main.cc"
  "${SRC_DIR}/meta_service.cc"
  "${SRC_DIR}/meta_service_status.cc"
  "${SRC_DIR}/metric_book.cc"
  "${SRC_DIR}/metric_listener.cc"
  "${SRC_DIR}/monitoring_stream.cc"
  "${SRC_DIR}/rebuild.cc"
  "${SRC_DIR}/reporting_stream.cc"
  "${SRC_DIR}/service_book.cc"
  "${SRC_DIR}/service_listener.cc"
  "${SRC_DIR}/timeperiod_map.cc"
  # Headers.
  "${INC_DIR}/availability_builder.hh"
  "${INC_DIR}/availability_thread.hh"
  "${INC_DIR}/ba.hh"
  "${INC_DIR}/ba_status.hh"
  "${INC_DIR}/ba_svc_mapping.hh"
  "${INC_DIR}/ba_event.hh"
  "${INC_DIR}/ba_duration_event.hh"
  "${INC_DIR}/bool_aggregate.hh"
  "${INC_DIR}/bool_and.hh"
  "${INC_DIR}/bool_binary_operator.hh"
  "${INC_DIR}/bool_call.hh"
  "${INC_DIR}/bool_constant.hh"
  "${INC_DIR}/bool_equal.hh"
  "${INC_DIR}/bool_expression.hh"
  "${INC_DIR}/bool_less_than.hh"
  "${INC_DIR}/bool_metric.hh"
  "${INC_DIR}/bool_more_than.hh"
  "${INC_DIR}/bool_not.hh"
  "${INC_DIR}/bool_not_equal.hh"
  "${INC_DIR}/bool_operation.hh"
  "${INC_DIR}/bool_or.hh"
  "${INC_DIR}/bool_service.hh"
  "${INC_DIR}/bool_value.hh"
  "${INC_DIR}/bool_xor.hh"
  "${INC_DIR}/computable.hh"
  "${INC_DIR}/configuration/applier/ba.hh"
  "${INC_DIR}/configuration/applier/bool_expression.hh"
  "${INC_DIR}/configuration/applier/kpi.hh"
  "${INC_DIR}/configuration/applier/meta_service.hh"
  "${INC_DIR}/configuration/applier/state.hh"
  "${INC_DIR}/configuration/ba.hh"
  "${INC_DIR}/configuration/bool_expression.hh"
  "${INC_DIR}/configuration/kpi.hh"
  "${INC_DIR}/configuration/meta_service.hh"
  "${INC_DIR}/configuration/reader.hh"
  "${INC_DIR}/configuration/reader_exception.hh"
  "${INC_DIR}/configuration/reader_v2.hh"
  "${INC_DIR}/configuration/state.hh"
  "${INC_DIR}/connector.hh"
  "${INC_DIR}/dimension_ba_event.hh"
  "${INC_DIR}/dimension_kpi_event.hh"
  "${INC_DIR}/dimension_ba_bv_relation_event.hh"
  "${INC_DIR}/dimension_bv_event.hh"
  "${INC_DIR}/dimension_timeperiod.hh"
  "${INC_DIR}/dimension_timeperiod_exception.hh"
  "${INC_DIR}/dimension_timeperiod_exclusion.hh"
  "${INC_DIR}/dimension_ba_timeperiod_relation.hh"
  "${INC_DIR}/dimension_truncate_table_signal.hh"
  "${INC_DIR}/events.hh"
  "${INC_DIR}/event_cache_visitor.hh"
  "${INC_DIR}/exp_builder.hh"
  "${INC_DIR}/exp_parser.hh"
  "${INC_DIR}/exp_tokenizer.hh"
  "${INC_DIR}/factory.hh"
  "${INC_DIR}/hst_svc_mapping.hh"
  "${INC_DIR}/impact_values.hh"
  "${INC_DIR}/internal.hh"
  "${INC_DIR}/inherited_downtime.hh"
  "${INC_DIR}/kpi.hh"
  "${INC_DIR}/kpi_ba.hh"
  "${INC_DIR}/kpi_boolexp.hh"
  "${INC_DIR}/kpi_event.hh"
  "${INC_DIR}/kpi_meta.hh"
  "${INC_DIR}/kpi_service.hh"
  "${INC_DIR}/kpi_status.hh"
  "${INC_DIR}/meta_service.hh"
  "${INC_DIR}/meta_service_status.hh"
  "${INC_DIR}/metric_book.hh"
  "${INC_DIR}/metric_listener.hh"
  "${INC_DIR}/monitoring_stream.hh"
  "${INC_DIR}/rebuild.hh"
  "${INC_DIR}/reporting_stream.hh"
  "${INC_DIR}/service_book.hh"
  "${INC_DIR}/service_listener.hh"
  "${INC_DIR}/timeperiod_map.hh"
)
target_link_libraries("${BAM}" ${QT_LIBRARIES})
set_target_properties("${BAM}" PROPERTIES PREFIX "")

# Testing.
set(
  TESTS_SOURCES
  ${TESTS_SOURCES}
  "${TEST_DIR}/exp_parser/get_postfix.cc"
  "${TEST_DIR}/exp_tokenizer/next.cc"
  "${TEST_DIR}/configuration/applier-boolexp.cc"
  PARENT_SCOPE
)
set(
  TESTS_LIBRARIES
  ${TESTS_LIBRARIES}
  "${BAM}"
  PARENT_SCOPE
)
if (0) # WITH_TESTING)
  set(TEST_LIBRARIES "${NEB}" "${BAM}" "roker")

  # ba tests.
  #   KPI change at recompute.
  set(TEST_NAME "bam_ba_kpi_change_at_recompute")
  add_executable("${TEST_NAME}"
    "${TEST_DIR}/ba/kpi_change_at_recompute.cc")
  target_link_libraries("${TEST_NAME}" ${TEST_LIBRARIES})
  add_test("${TEST_NAME}" "${TEST_NAME}")

  # time tests.
  set(CHECK_TIMEPERIOD "check_timeperiod")
  add_executable("${CHECK_TIMEPERIOD}"
    "${TEST_DIR}/time/check_timeperiod.cc")
  target_link_libraries("${CHECK_TIMEPERIOD}" ${TEST_LIBRARIES})
  #   Week days tests.
  add_test("bam_time_week_day_after_period"
    "${CHECK_TIMEPERIOD}" "${TEST_DIR}/time/cfg/week_day/after_period.conf")
  add_test("bam_time_week_day_before_period"
    "${CHECK_TIMEPERIOD}" "${TEST_DIR}/time/cfg/week_day/before_period.conf")
  add_test("bam_time_week_day_into_period"
    "${CHECK_TIMEPERIOD}" "${TEST_DIR}/time/cfg/week_day/into_period.conf")
  add_test("bam_time_week_day_into_period_for_next_week"
    "${CHECK_TIMEPERIOD}" "${TEST_DIR}/time/cfg/week_day/into_period_for_next_week.conf")
  add_test("bam_time_week_day_into_period_with_exclude_after"
    "${CHECK_TIMEPERIOD}" "${TEST_DIR}/time/cfg/week_day/into_period_with_exclude_after.conf")
  add_test("bam_time_week_day_into_period_with_exclude_before"
    "${CHECK_TIMEPERIOD}" "${TEST_DIR}/time/cfg/week_day/into_period_with_exclude_before.conf")
  add_test("bam_time_week_day_into_period_with_exclude_into"
    "${CHECK_TIMEPERIOD}" "${TEST_DIR}/time/cfg/week_day/into_period_with_exclude_into.conf")
  #   Exceptions tests.
  #     Calendar date.
  add_test("bam_time_exception_calendar_date_after_period"
    "${CHECK_TIMEPERIOD}" "${TEST_DIR}/time/cfg/exception/calendar_date/after_period.conf")
  add_test("bam_time_exception_calendar_date_before_period"
    "${CHECK_TIMEPERIOD}" "${TEST_DIR}/time/cfg/exception/calendar_date/before_period.conf")
  add_test("bam_time_exception_calendar_date_into_period"
    "${CHECK_TIMEPERIOD}" "${TEST_DIR}/time/cfg/exception/calendar_date/into_period.conf")
  add_test("bam_time_exception_calendar_date_into_period_with_exclude_after"
    "${CHECK_TIMEPERIOD}" "${TEST_DIR}/time/cfg/exception/calendar_date/into_period_with_exclude_after.conf")
  add_test("bam_time_exception_calendar_date_into_period_with_exclude_before"
    "${CHECK_TIMEPERIOD}" "${TEST_DIR}/time/cfg/exception/calendar_date/into_period_with_exclude_before.conf")
  add_test("bam_time_exception_calendar_date_into_period_with_exclude_into"
    "${CHECK_TIMEPERIOD}" "${TEST_DIR}/time/cfg/exception/calendar_date/into_period_with_exclude_into.conf")
  add_test("bam_time_exception_calendar_date_skip_in_after_period"
    "${CHECK_TIMEPERIOD}" "${TEST_DIR}/time/cfg/exception/calendar_date/skip_in_after_period.conf")
  add_test("bam_time_exception_calendar_date_skip_in_before_period"
    "${CHECK_TIMEPERIOD}" "${TEST_DIR}/time/cfg/exception/calendar_date/skip_in_before_period.conf")
  add_test("bam_time_exception_calendar_date_skip_in_into_period"
    "${CHECK_TIMEPERIOD}" "${TEST_DIR}/time/cfg/exception/calendar_date/skip_in_into_period.conf")
  add_test("bam_time_exception_calendar_date_skip_in_into_period_with_exclude_after"
    "${CHECK_TIMEPERIOD}" "${TEST_DIR}/time/cfg/exception/calendar_date/skip_in_into_period_with_exclude_after.conf")
  add_test("bam_time_exception_calendar_date_skip_in_into_period_with_exclude_before"
    "${CHECK_TIMEPERIOD}" "${TEST_DIR}/time/cfg/exception/calendar_date/skip_in_into_period_with_exclude_before.conf")
  add_test("bam_time_exception_calendar_date_skip_in_into_period_with_exclude_into"
    "${CHECK_TIMEPERIOD}" "${TEST_DIR}/time/cfg/exception/calendar_date/skip_in_into_period_with_exclude_into.conf")
  add_test("bam_time_exception_calendar_date_start_end_skip_in_after_period"
    "${CHECK_TIMEPERIOD}" "${TEST_DIR}/time/cfg/exception/calendar_date/start_end_skip_in_after_period.conf")
  add_test("bam_time_exception_calendar_date_start_end_skip_in_before_period"
    "${CHECK_TIMEPERIOD}" "${TEST_DIR}/time/cfg/exception/calendar_date/start_end_skip_in_before_period.conf")
  add_test("bam_time_exception_calendar_date_start_end_skip_in_into_period"
    "${CHECK_TIMEPERIOD}" "${TEST_DIR}/time/cfg/exception/calendar_date/start_end_skip_in_into_period.conf")
  add_test("bam_time_exception_calendar_date_start_end_skip_in_into_period_with_exclude_after"
    "${CHECK_TIMEPERIOD}" "${TEST_DIR}/time/cfg/exception/calendar_date/start_end_skip_in_into_period_with_exclude_after.conf")
  add_test("bam_time_exception_calendar_date_start_end_skip_in_into_period_with_exclude_before"
    "${CHECK_TIMEPERIOD}" "${TEST_DIR}/time/cfg/exception/calendar_date/start_end_skip_in_into_period_with_exclude_before.conf")
  add_test("bam_time_exception_calendar_date_start_end_skip_in_into_period_with_exclude_into"
    "${CHECK_TIMEPERIOD}" "${TEST_DIR}/time/cfg/exception/calendar_date/start_end_skip_in_into_period_with_exclude_into.conf")
  add_test("bam_time_exception_calendar_date_start_end_skip_out_after_period"
    "${CHECK_TIMEPERIOD}" "${TEST_DIR}/time/cfg/exception/calendar_date/start_end_skip_out_after_period.conf")
  add_test("bam_time_exception_calendar_date_start_end_skip_out_after_period_with_exclude_after"

=== build/correlation/CMakeLists.txt ===
##
## Copyright 2011-2013 Centreon
##
## Licensed under the Apache License, Version 2.0 (the "License");
## you may not use this file except in compliance with the License.
## You may obtain a copy of the License at
##
##     http://www.apache.org/licenses/LICENSE-2.0
##
## Unless required by applicable law or agreed to in writing, software
## distributed under the License is distributed on an "AS IS" BASIS,
## WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
## See the License for the specific language governing permissions and
## limitations under the License.
##
## For more information : contact@centreon.com
##

# Global options.
set(INC_DIR "${PROJECT_SOURCE_DIR}/correlation/inc")
set(SRC_DIR "${PROJECT_SOURCE_DIR}/correlation/src")
set(TEST_DIR "${PROJECT_SOURCE_DIR}/correlation/test")
include_directories("${INC_DIR}")
include_directories("${PROJECT_SOURCE_DIR}")
include_directories("${PROJECT_SOURCE_DIR}/neb/inc")
set(INC_DIR "${INC_DIR}/com/centreon/broker/correlation")

# Some files must be processed by Qt's moc.
unset(QT_WRAPPED_SOURCES)

# Correlation module.
set(CORRELATION "30-correlation")
set(CORRELATION "${CORRELATION}" PARENT_SCOPE)
add_library("${CORRELATION}" SHARED
  # Sources.
  "${SRC_DIR}/connector.cc"
  "${SRC_DIR}/engine_state.cc"
  "${SRC_DIR}/factory.cc"
  "${SRC_DIR}/issue.cc"
  "${SRC_DIR}/issue_parent.cc"
  "${SRC_DIR}/log_issue.cc"
  "${SRC_DIR}/main.cc"
  "${SRC_DIR}/node.cc"
  "${SRC_DIR}/parser.cc"
  "${SRC_DIR}/state.cc"
  "${SRC_DIR}/stream.cc"
  # Headers.
  "${INC_DIR}/connector.hh"
  "${INC_DIR}/engine_state.hh"
  "${INC_DIR}/events.hh"
  "${INC_DIR}/factory.hh"
  "${INC_DIR}/internal.hh"
  "${INC_DIR}/issue.hh"
  "${INC_DIR}/issue_parent.hh"
  "${INC_DIR}/log_issue.hh"
  "${INC_DIR}/node.hh"
  "${INC_DIR}/parser.hh"
  "${INC_DIR}/state.hh"
  "${INC_DIR}/stream.hh"
  # Qt-processed files.
  ${QT_WRAPPED_SOURCES}
)
target_link_libraries("${CORRELATION}" ${QT_LIBRARIES})
set_target_properties("${CORRELATION}" PROPERTIES PREFIX "")

# Testing.
if (0) # WITH_TESTING)
  include_directories("${PROJECT_SOURCE_DIR}/correlation")
  set(TEST_LIBRARIES "${NOTIFICATION}" "${CORRELATION}" "${NEB}" "rokerbase" "roker")

  # Generate files.
  configure_file("${TEST_DIR}/parser/parse_include.xml.in"
    "${TEST_DIR}/parser/parse_include.xml")

  # state tests.
  #   Default construction.
  set(TEST_NAME "correlation_state_ctor_default")
  add_executable("${TEST_NAME}"
    "${TEST_DIR}/state/ctor_default.cc")
  target_link_libraries("${TEST_NAME}" ${TEST_LIBRARIES})
  add_test("${TEST_NAME}" "${TEST_NAME}")
  #   Copy construction.
  set(TEST_NAME "correlation_state_ctor_copy")
  add_executable("${TEST_NAME}"
    "${TEST_DIR}/state/ctor_copy.cc")
  target_link_libraries("${TEST_NAME}" ${TEST_LIBRARIES})
  add_test("${TEST_NAME}" "${TEST_NAME}")
  #   Assignment.
  set(TEST_NAME "correlation_state_assignment")
  add_executable("${TEST_NAME}"
    "${TEST_DIR}/state/assignment.cc")
  target_link_libraries("${TEST_NAME}" ${TEST_LIBRARIES})
  add_test("${TEST_NAME}" "${TEST_NAME}")
  #   Equality.
  set(TEST_NAME "correlation_state_equality")
  add_executable("${TEST_NAME}"
    "${TEST_DIR}/state/equality.cc")
  target_link_libraries("${TEST_NAME}" ${TEST_LIBRARIES})
  add_test("${TEST_NAME}" "${TEST_NAME}")
  #   Non-equality.
  set(TEST_NAME "correlation_state_non_equality")
  add_executable("${TEST_NAME}"
    "${TEST_DIR}/state/non_equality.cc")
  target_link_libraries("${TEST_NAME}" ${TEST_LIBRARIES})
  add_test("${TEST_NAME}" "${TEST_NAME}")
  # issue tests.
  #   Default construction.
  set(TEST_NAME "correlation_issue_ctor_default")
  add_executable("${TEST_NAME}"
    "${TEST_DIR}/issue/ctor_default.cc")
  target_link_libraries("${TEST_NAME}" ${TEST_LIBRARIES})
  add_test("${TEST_NAME}" "${TEST_NAME}")
  #   Copy construction.
  set(TEST_NAME "correlation_issue_ctor_copy")
  add_executable("${TEST_NAME}"
    "${TEST_DIR}/issue/ctor_copy.cc")
  target_link_libraries("${TEST_NAME}" ${TEST_LIBRARIES})
  add_test("${TEST_NAME}" "${TEST_NAME}")
  #   Assignment.
  set(TEST_NAME "correlation_issue_assignment")
  add_executable("${TEST_NAME}"
    "${TEST_DIR}/issue/assignment.cc")
  target_link_libraries("${TEST_NAME}" ${TEST_LIBRARIES})
  add_test("${TEST_NAME}" "${TEST_NAME}")
  #   Equality.
  set(TEST_NAME "correlation_issue_equality")
  add_executable("${TEST_NAME}"
    "${TEST_DIR}/issue/equality.cc")
  target_link_libraries("${TEST_NAME}" ${TEST_LIBRARIES})
  add_test("${TEST_NAME}" "${TEST_NAME}")
  #   Non-equality.
  set(TEST_NAME "correlation_issue_non_equality")
  add_executable("${TEST_NAME}"
    "${TEST_DIR}/issue/non_equality.cc")
  target_link_libraries("${TEST_NAME}" ${TEST_LIBRARIES})
  add_test("${TEST_NAME}" "${TEST_NAME}")
  # issue_parent tests.
  #   Default construction.
  set(TEST_NAME "correlation_issue_parent_ctor_default")
  add_executable("${TEST_NAME}"
    "${TEST_DIR}/issue_parent/ctor_default.cc")
  target_link_libraries("${TEST_NAME}" ${TEST_LIBRARIES})
  add_test("${TEST_NAME}" "${TEST_NAME}")
  #   Copy construction.
  set(TEST_NAME "correlation_issue_parent_ctor_copy")
  add_executable("${TEST_NAME}"
    "${TEST_DIR}/issue_parent/ctor_copy.cc")
  target_link_libraries("${TEST_NAME}" ${TEST_LIBRARIES})
  add_test("${TEST_NAME}" "${TEST_NAME}")
  #   Assignment.
  set(TEST_NAME "correlation_issue_parent_ctor_assignment")
  add_executable("${TEST_NAME}"
    "${TEST_DIR}/issue_parent/assignment.cc")
  target_link_libraries("${TEST_NAME}" ${TEST_LIBRARIES})
  add_test("${TEST_NAME}" "${TEST_NAME}")
  # node tests.
  #   Default construction.
  set(TEST_NAME "correlation_node_ctor_default")
  add_executable("${TEST_NAME}"
    "${TEST_DIR}/node/ctor_default.cc")
  target_link_libraries("${TEST_NAME}" ${TEST_LIBRARIES})
  add_test("${TEST_NAME}" "${TEST_NAME}")
  #   Child link creation.
  set(TEST_NAME "correlation_node_add_child")
  add_executable("${TEST_NAME}"
    "${TEST_DIR}/node/add_child.cc")
  target_link_libraries("${TEST_NAME}" ${TEST_LIBRARIES})
  add_test("${TEST_NAME}" "${TEST_NAME}")
  #   Depended link creation.
  set(TEST_NAME "correlation_node_add_depended")
  add_executable("${TEST_NAME}"
    "${TEST_DIR}/node/add_depended.cc")
  target_link_libraries("${TEST_NAME}" ${TEST_LIBRARIES})
  add_test("${TEST_NAME}" "${TEST_NAME}")
  #   Dependency link creation.
  set(TEST_NAME "correlation_node_add_dependency")
  add_executable("${TEST_NAME}"
    "${TEST_DIR}/node/add_dependency")
  target_link_libraries("${TEST_NAME}" ${TEST_LIBRARIES})
  add_test("${TEST_NAME}" "${TEST_NAME}")
  #   Parent link creation.
  set(TEST_NAME "correlation_node_add_parent")
  add_executable("${TEST_NAME}"
    "${TEST_DIR}/node/add_parent.cc")
  target_link_libraries("${TEST_NAME}" ${TEST_LIBRARIES})
  add_test("${TEST_NAME}" "${TEST_NAME}")
  #   Child link deletion.
  set(TEST_NAME "correlation_node_remove_child")
  add_executable("${TEST_NAME}"
    "${TEST_DIR}/node/remove_child.cc")
  target_link_libraries("${TEST_NAME}" ${TEST_LIBRARIES})
  add_test("${TEST_NAME}" "${TEST_NAME}")
  #   Depended link deletion.
  set(TEST_NAME "correlation_node_remove_depended")
  add_executable("${TEST_NAME}"
    "${TEST_DIR}/node/remove_depended.cc")
  target_link_libraries("${TEST_NAME}" ${TEST_LIBRARIES})
  add_test("${TEST_NAME}" "${TEST_NAME}")
  #   Dependency link deletion.
  set(TEST_NAME "correlation_node_remove_dependency")
  add_executable("${TEST_NAME}"
    "${TEST_DIR}/node/remove_dependency")
  target_link_libraries("${TEST_NAME}" ${TEST_LIBRARIES})
  add_test("${TEST_NAME}" "${TEST_NAME}")
  #   Parent link deletion.
  set(TEST_NAME "correlation_node_remove_parent")
  add_executable("${TEST_NAME}"
    "${TEST_DIR}/node/remove_parent.cc")
  target_link_libraries("${TEST_NAME}" ${TEST_LIBRARIES})
  add_test("${TEST_NAME}" "${TEST_NAME}")
  #   Copy construction.
  set(TEST_NAME "correlation_node_ctor_copy")
  add_executable("${TEST_NAME}"
    "${TEST_DIR}/node/ctor_copy.cc")
  target_link_libraries("${TEST_NAME}" ${TEST_LIBRARIES})
  add_test("${TEST_NAME}" "${TEST_NAME}")
  #   Assignment.
  set(TEST_NAME "correlation_node_assignment")
  add_executable("${TEST_NAME}"
    "${TEST_DIR}/node/assignment.cc")
  target_link_libraries("${TEST_NAME}" ${TEST_LIBRARIES})
  add_test("${TEST_NAME}" "${TEST_NAME}")
  #   On child destruction.
  set(TEST_NAME "correlation_node_on_destroy_child")
  add_executable("${TEST_NAME}"
    "${TEST_DIR}/node/on_destroy_child.cc")
  target_link_libraries("${TEST_NAME}" ${TEST_LIBRARIES})
  add_test("${TEST_NAME}" "${TEST_NAME}")
  #   On depended destruction.
  set(TEST_NAME "correlation_node_on_destroy_depended")
  add_executable("${TEST_NAME}"
    "${TEST_DIR}/node/on_destroy_depended.cc")
  target_link_libraries("${TEST_NAME}" ${TEST_LIBRARIES})
  add_test("${TEST_NAME}" "${TEST_NAME}")
  #   On dependency destruction.
  set(TEST_NAME "correlation_node_on_destroy_dependency")
  add_executable("${TEST_NAME}"
    "${TEST_DIR}/node/on_destroy_dependency.cc")
  target_link_libraries("${TEST_NAME}" ${TEST_LIBRARIES})
  add_test("${TEST_NAME}" "${TEST_NAME}")
  #   On parent destruction.
  set(TEST_NAME "correlation_node_on_destroy_parent")
  add_executable("${TEST_NAME}"
    "${TEST_DIR}/node/on_destroy_parent.cc")
  target_link_libraries("${TEST_NAME}" ${TEST_LIBRARIES})
  add_test("${TEST_NAME}" "${TEST_NAME}")
  #   Equality.
  set(TEST_NAME "correlation_node_equality")
  add_executable("${TEST_NAME}"
    "${TEST_DIR}/node/equality.cc")
  target_link_libraries("${TEST_NAME}" ${TEST_LIBRARIES})
  add_test("${TEST_NAME}" "${TEST_NAME}")
  #   Non-equality.
  set(TEST_NAME "correlation_node_non_equality")
  add_executable("${TEST_NAME}"
    "${TEST_DIR}/node/non_equality.cc")
  target_link_libraries("${TEST_NAME}" ${TEST_LIBRARIES})
  add_test("${TEST_NAME}" "${TEST_NAME}")
  # parser tests.
  add_library("ccb_correlation_parser"
    STATIC
    "${TEST_DIR}/parser/common.cc")
  #   Non-retention file loading.
  set(TEST_NAME "correlation_parser_parse_non_retention")
  add_executable("${TEST_NAME}"
    "${TEST_DIR}/parser/parse_non_retention.cc"
    "${TEST_DIR}/parser/common.hh")
  target_link_libraries("${TEST_NAME}"
    "ccb_correlation_parser"
    ${TEST_LIBRARIES})
  add_test("${TEST_NAME}" "${TEST_NAME}")
  #   Retention file loading.
  set(TEST_NAME "correlation_parser_parse_retention")
  add_executable("${TEST_NAME}"
    "${TEST_DIR}/parser/parse_retention.cc"
    "${TEST_DIR}/parser/common.hh")
  target_link_libraries("${TEST_NAME}"
    "ccb_correlation_parser"
    ${TEST_LIBRARIES})
  add_test("${TEST_NAME}" "${TEST_NAME}")
  #   Include directive.
  set(TEST_NAME "correlation_parser_parse_include")
  add_executable("${TEST_NAME}"
    "${TEST_DIR}/parser/parse_include.cc"
    "${TEST_DIR}/parser/common.hh")
  target_link_libraries("${TEST_NAME}"
    "ccb_correlation_parser"
    ${TEST_LIBRARIES})
  add_test("${TEST_NAME}" "${TEST_NAME}")
  # correlator tests.
  add_library("ccb_correlation_correlator"
    STATIC
    "${TEST_DIR}/correlator/common.cc")
  #   Set correlator state.
  set(TEST_NAME "correlation_correlator_set_state")
  add_executable("${TEST_NAME}"
    "${TEST_DIR}/correlator/set_state.cc")
  target_link_libraries("${TEST_NAME}" ${TEST_LIBRARIES})
  add_test("${TEST_NAME}" "${TEST_NAME}")
  #   Start/stop.
  set(TEST_NAME "correlation_correlator_start_stop")
  add_executable("${TEST_NAME}"
    "${TEST_DIR}/correlator/start_stop.cc"
    "${TEST_DIR}/correlator/common.hh")
  target_link_libraries("${TEST_NAME}"
    "ccb_correlation_correlator"
    ${TEST_LIBRARIES})
  add_test("${TEST_NAME}" "${TEST_NAME}")
  #   Issue creation and deletion.
  set(TEST_NAME "correlation_correlator_issue")
  add_executable("${TEST_NAME}"
    "${TEST_DIR}/correlator/issue.cc"
    "${TEST_DIR}/correlator/common.hh")
  target_link_libraries("${TEST_NAME}"
    "ccb_correlation_correlator"
    ${TEST_LIBRARIES})
  add_test("${TEST_NAME}" "${TEST_NAME}")

=== build/dumper/CMakeLists.txt ===
##
## Copyright 2013,2015 Centreon
##
## Licensed under the Apache License, Version 2.0 (the "License");
## you may not use this file except in compliance with the License.
## You may obtain a copy of the License at
##
##     http://www.apache.org/licenses/LICENSE-2.0
##
## Unless required by applicable law or agreed to in writing, software
## distributed under the License is distributed on an "AS IS" BASIS,
## WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
## See the License for the specific language governing permissions and
## limitations under the License.
##
## For more information : contact@centreon.com
##

# Global options.
set(INC_DIR "${PROJECT_SOURCE_DIR}/dumper/inc/com/centreon/broker/dumper")
set(SRC_DIR "${PROJECT_SOURCE_DIR}/dumper/src")
set(TEST_DIR "${PROJECT_SOURCE_DIR}/dumper/test")
include_directories("${PROJECT_SOURCE_DIR}/dumper/inc")
include_directories("${PROJECT_SOURCE_DIR}/storage/inc")

# Dumper module.
set(DUMPER "05-dumper")
set(DUMPER "${DUMPER}" PARENT_SCOPE)
add_library("${DUMPER}" SHARED
  # Sources.
  "${SRC_DIR}/db_dump.cc"
  "${SRC_DIR}/db_dump_committed.cc"
  "${SRC_DIR}/db_loader.cc"
  "${SRC_DIR}/db_loader_v2.cc"
  "${SRC_DIR}/db_loader_v3.cc"
  "${SRC_DIR}/db_reader.cc"
  "${SRC_DIR}/db_writer.cc"
  "${SRC_DIR}/directory_dump.cc"
  "${SRC_DIR}/directory_dumper.cc"
  "${SRC_DIR}/directory_dump_committed.cc"
  "${SRC_DIR}/dump.cc"
  "${SRC_DIR}/entries/ba.cc"
  "${SRC_DIR}/entries/ba_type.cc"
  "${SRC_DIR}/entries/boolean.cc"
  "${SRC_DIR}/entries/diff.cc"
  "${SRC_DIR}/entries/host.cc"
  "${SRC_DIR}/entries/kpi.cc"
  "${SRC_DIR}/entries/organization.cc"
  "${SRC_DIR}/entries/service.cc"
  "${SRC_DIR}/entries/state.cc"
  "${SRC_DIR}/factory.cc"
  "${SRC_DIR}/fifo_dumper.cc"
  "${SRC_DIR}/main.cc"
  "${SRC_DIR}/opener.cc"
  "${SRC_DIR}/remove.cc"
  "${SRC_DIR}/stream.cc"
  "${SRC_DIR}/timestamp_cache.cc"
  # Headers.
  "${INC_DIR}/db_dump.hh"
  "${INC_DIR}/db_dump_committed.hh"
  "${INC_DIR}/db_loader.hh"
  "${INC_DIR}/db_loader_v2.hh"
  "${INC_DIR}/db_loader_v3.hh"
  "${INC_DIR}/db_reader.hh"
  "${INC_DIR}/db_writer.hh"
  "${INC_DIR}/directory_dump.hh"
  "${INC_DIR}/directory_dumper.hh"
  "${INC_DIR}/directory_dump_committed.hh"
  "${INC_DIR}/dump.hh"
  "${INC_DIR}/entries/ba.hh"
  "${INC_DIR}/entries/ba_type.hh"
  "${INC_DIR}/entries/boolean.hh"
  "${INC_DIR}/entries/diff.hh"
  "${INC_DIR}/entries/host.hh"
  "${INC_DIR}/entries/kpi.hh"
  "${INC_DIR}/entries/organization.hh"
  "${INC_DIR}/entries/service.hh"
  "${INC_DIR}/entries/state.hh"
  "${INC_DIR}/factory.hh"
  "${INC_DIR}/fifo_dumper.hh"
  "${INC_DIR}/internal.hh"
  "${INC_DIR}/opener.hh"
  "${INC_DIR}/remove.hh"
  "${INC_DIR}/stream.hh"
  "${INC_DIR}/timestamp_cache.hh"
)
target_link_libraries("${DUMPER}" ${QT_LIBRARIES})
set_target_properties("${DUMPER}" PROPERTIES PREFIX "")

if (WITH_TESTING)
  set(TEST_LIBRARIES "${DUMPER}" "roker")

endif ()

# Install rule.
install(TARGETS "${DUMPER}"
  LIBRARY DESTINATION "${PREFIX_MODULES}"
)

=== build/graphite/CMakeLists.txt ===
##
## Copyright 2011-2015 Centreon
##
## Licensed under the Apache License, Version 2.0 (the "License");
## you may not use this file except in compliance with the License.
## You may obtain a copy of the License at
##
##     http://www.apache.org/licenses/LICENSE-2.0
##
## Unless required by applicable law or agreed to in writing, software
## distributed under the License is distributed on an "AS IS" BASIS,
## WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
## See the License for the specific language governing permissions and
## limitations under the License.
##
## For more information : contact@centreon.com
##

# Global options.
set(INC_DIR "${PROJECT_SOURCE_DIR}/graphite/inc")
set(SRC_DIR "${PROJECT_SOURCE_DIR}/graphite/src")
set(TEST_DIR "${PROJECT_SOURCE_DIR}/graphite/test")
include_directories("${INC_DIR}")
include_directories("${PROJECT_SOURCE_DIR}/neb/inc")
include_directories("${PROJECT_SOURCE_DIR}/storage/inc")
set(INC_DIR "${INC_DIR}/com/centreon/broker/graphite")

# GRAPHITE module.
set(GRAPHITE "70-graphite")
set(GRAPHITE "${GRAPHITE}" PARENT_SCOPE)
add_library("${GRAPHITE}" SHARED
  # Sources.
  "${SRC_DIR}/main.cc"
  "${SRC_DIR}/factory.cc"
  "${SRC_DIR}/stream.cc"
  "${SRC_DIR}/connector.cc"
  "${SRC_DIR}/query.cc"
  "${SRC_DIR}/macro_cache.cc"
  # Headers.
  "${INC_DIR}/factory.hh"
  "${INC_DIR}/stream.hh"
  "${INC_DIR}/connector.hh"
  "${INC_DIR}/query.hh"
  "${INC_DIR}/macro_cache.hh"
)
target_link_libraries("${GRAPHITE}" ${QT_LIBRARIES})
set_target_properties("${GRAPHITE}" PROPERTIES PREFIX "")

# Testing.
if (WITH_TESTING)
  set(TEST_LIBRARIES "${NEB}" "${GRAPHITE}" "roker")

endif ()

# Install rule.
install(TARGETS "${GRAPHITE}"
  LIBRARY DESTINATION "${PREFIX_MODULES}"
)

=== build/influxdb/CMakeLists.txt ===
##
## Copyright 2011-2017 Centreon
##
## Licensed under the Apache License, Version 2.0 (the "License");
## you may not use this file except in compliance with the License.
## You may obtain a copy of the License at
##
##     http://www.apache.org/licenses/LICENSE-2.0
##
## Unless required by applicable law or agreed to in writing, software
## distributed under the License is distributed on an "AS IS" BASIS,
## WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
## See the License for the specific language governing permissions and
## limitations under the License.
##
## For more information : contact@centreon.com
##

# Global options.
set(INC_DIR "${PROJECT_SOURCE_DIR}/influxdb/inc")
set(SRC_DIR "${PROJECT_SOURCE_DIR}/influxdb/src")
set(TEST_DIR "${PROJECT_SOURCE_DIR}/test")
include_directories("${INC_DIR}")
include_directories("${PROJECT_SOURCE_DIR}/neb/inc")
include_directories("${PROJECT_SOURCE_DIR}/storage/inc")
set(INC_DIR "${INC_DIR}/com/centreon/broker/influxdb")

# INFLUXDB module.
set(INFLUXDB "70-influxdb")
set(INFLUXDB "${INFLUXDB}" PARENT_SCOPE)
add_library("${INFLUXDB}" SHARED
  # Sources.
  "${SRC_DIR}/column.cc"
  "${SRC_DIR}/connector.cc"
  "${SRC_DIR}/factory.cc"
  "${SRC_DIR}/influxdb12.cc"
  "${SRC_DIR}/json_printer.cc"
  "${SRC_DIR}/line_protocol_query.cc"
  "${SRC_DIR}/macro_cache.cc"
  "${SRC_DIR}/main.cc"
  "${SRC_DIR}/stream.cc"
  # Headers.
  "${INC_DIR}/column.hh"
  "${INC_DIR}/connector.hh"
  "${INC_DIR}/factory.hh"
  "${INC_DIR}/influxdb.hh"
  "${INC_DIR}/influxdb12.hh"
  "${INC_DIR}/json_printer.hh"
  "${INC_DIR}/line_protocol_query.hh"
  "${INC_DIR}/macro_cache.hh"
  "${INC_DIR}/stream.hh"
)
target_link_libraries("${INFLUXDB}" ${QT_LIBRARIES})
set_target_properties("${INFLUXDB}" PROPERTIES PREFIX "")

# Testing.
if (WITH_TESTING)
  set(TEST_LIBRARIES "${NEB}" "${INFLUXDB}" "roker")

endif ()

# Install rule.
install(TARGETS "${INFLUXDB}"
  LIBRARY DESTINATION "${PREFIX_MODULES}"
)

=== build/lua/CMakeLists.txt ===
##
## Copyright 2018 Centreon
##
## Licensed under the Apache License, Version 2.0 (the "License");
## you may not use this file except in compliance with the License.
## You may obtain a copy of the License at
##
##     http://www.apache.org/licenses/LICENSE-2.0
##
## Unless required by applicable law or agreed to in writing, software
## distributed under the License is distributed on an "AS IS" BASIS,
## WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
## See the License for the specific language governing permissions and
## limitations under the License.
##
## For more information : contact@centreon.com
##

# Global options.

set(INC_DIR "${PROJECT_SOURCE_DIR}/lua/inc")
set(SRC_DIR "${PROJECT_SOURCE_DIR}/lua/src")
set(TEST_DIR "${PROJECT_SOURCE_DIR}/lua/test")
include_directories("${INC_DIR}")
include_directories("${PROJECT_SOURCE_DIR}/bam/inc")
include_directories("${PROJECT_SOURCE_DIR}/neb/inc")
include_directories("${PROJECT_SOURCE_DIR}/storage/inc")
set(INC_DIR "${INC_DIR}/com/centreon/broker/lua")

# Storage module.
set(LUA "70-lua")
set(LUA "${LUA}" PARENT_SCOPE)
add_library("${LUA}" SHARED
  # Sources.
  "${SRC_DIR}/broker_cache.cc"
  "${SRC_DIR}/broker_log.cc"
  "${SRC_DIR}/broker_socket.cc"
  "${SRC_DIR}/broker_utils.cc"
  "${SRC_DIR}/connector.cc"
  "${SRC_DIR}/factory.cc"
  "${SRC_DIR}/luabinding.cc"
  "${SRC_DIR}/macro_cache.cc"
  "${SRC_DIR}/main.cc"
  "${SRC_DIR}/stream.cc"
  # Headers.
  "${INC_DIR}/broker_cache.hh"
  "${INC_DIR}/broker_log.hh"
  "${INC_DIR}/broker_socket.hh"
  "${INC_DIR}/broker_utils.hh"
  "${INC_DIR}/connector.hh"
  "${INC_DIR}/factory.hh"
  "${INC_DIR}/luabinding.hh"
  "${INC_DIR}/macro_cache.hh"
  "${INC_DIR}/stream.hh"
)
target_link_libraries("${LUA}" ${QT_LIBRARIES} ${LUA_LIBRARIES})
set_target_properties("${LUA}" PROPERTIES PREFIX "")

# Testing.
set(
  TESTS_SOURCES
  ${TESTS_SOURCES}
  "${TEST_DIR}/lua.cc"
  PARENT_SCOPE
)
set(
  TESTS_LIBRARIES
  ${TESTS_LIBRARIES}
  "${LUA}"
  PARENT_SCOPE
)

# Install rule.
install(TARGETS "${LUA}"
  LIBRARY DESTINATION "${PREFIX_MODULES}"
)

=== build/neb/CMakeLists.txt ===
##
## Copyright 2009-2013,2015 Centreon
##
## Licensed under the Apache License, Version 2.0 (the "License");
## you may not use this file except in compliance with the License.
## You may obtain a copy of the License at
##
##     http://www.apache.org/licenses/LICENSE-2.0
##
## Unless required by applicable law or agreed to in writing, software
## distributed under the License is distributed on an "AS IS" BASIS,
## WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
## See the License for the specific language governing permissions and
## limitations under the License.
##
## For more information : contact@centreon.com
##

# Global options.
set(INC_DIR "${PROJECT_SOURCE_DIR}/neb/inc")
set(SRC_DIR "${PROJECT_SOURCE_DIR}/neb/src")
set(TEST_DIR "${PROJECT_SOURCE_DIR}/neb/test")
include_directories("${INC_DIR}")

# NEB sources.
set(NEB_SOURCES
  # Sources.
  "${SRC_DIR}/acknowledgement.cc"
  "${SRC_DIR}/check.cc"
  "${SRC_DIR}/comment.cc"
  "${SRC_DIR}/custom_variable.cc"
  "${SRC_DIR}/custom_variable_status.cc"
  "${SRC_DIR}/dependency.cc"
  "${SRC_DIR}/downtime.cc"
  "${SRC_DIR}/event_handler.cc"
  "${SRC_DIR}/flapping_status.cc"
  "${SRC_DIR}/group.cc"
  "${SRC_DIR}/group_member.cc"
  "${SRC_DIR}/host.cc"
  "${SRC_DIR}/host_check.cc"
  "${SRC_DIR}/host_dependency.cc"
  "${SRC_DIR}/host_group.cc"
  "${SRC_DIR}/host_group_member.cc"
  "${SRC_DIR}/host_parent.cc"
  "${SRC_DIR}/host_service.cc"
  "${SRC_DIR}/host_service_status.cc"
  "${SRC_DIR}/host_status.cc"
  "${SRC_DIR}/instance.cc"
  "${SRC_DIR}/instance_configuration.cc"
  "${SRC_DIR}/instance_status.cc"
  "${SRC_DIR}/log_entry.cc"
  "${SRC_DIR}/module.cc"
  "${SRC_DIR}/service.cc"
  "${SRC_DIR}/service_check.cc"
  "${SRC_DIR}/service_dependency.cc"
  "${SRC_DIR}/service_group.cc"
  "${SRC_DIR}/service_group_member.cc"
  "${SRC_DIR}/service_status.cc"
  "${SRC_DIR}/status.cc"
  # Headers.
  "${INC_DIR}/com/centreon/broker/neb/acknowledgement.hh"
  "${INC_DIR}/com/centreon/broker/neb/check.hh"
  "${INC_DIR}/com/centreon/broker/neb/comment.hh"
  "${INC_DIR}/com/centreon/broker/neb/custom_variable.hh"
  "${INC_DIR}/com/centreon/broker/neb/custom_variable_status.hh"
  "${INC_DIR}/com/centreon/broker/neb/dependency.hh"
  "${INC_DIR}/com/centreon/broker/neb/downtime.hh"
  "${INC_DIR}/com/centreon/broker/neb/event_handler.hh"
  "${INC_DIR}/com/centreon/broker/neb/events.hh"
  "${INC_DIR}/com/centreon/broker/neb/flapping_status.hh"
  "${INC_DIR}/com/centreon/broker/neb/group.hh"
  "${INC_DIR}/com/centreon/broker/neb/group_member.hh"
  "${INC_DIR}/com/centreon/broker/neb/host.hh"
  "${INC_DIR}/com/centreon/broker/neb/host_check.hh"
  "${INC_DIR}/com/centreon/broker/neb/host_dependency.hh"
  "${INC_DIR}/com/centreon/broker/neb/host_group.hh"
  "${INC_DIR}/com/centreon/broker/neb/host_group_member.hh"
  "${INC_DIR}/com/centreon/broker/neb/host_parent.hh"
  "${INC_DIR}/com/centreon/broker/neb/host_service.hh"
  "${INC_DIR}/com/centreon/broker/neb/host_service_status.hh"
  "${INC_DIR}/com/centreon/broker/neb/host_status.hh"
  "${INC_DIR}/com/centreon/broker/neb/instance.hh"
  "${INC_DIR}/com/centreon/broker/neb/instance_configuration.hh"
  "${INC_DIR}/com/centreon/broker/neb/instance_status.hh"
  "${INC_DIR}/com/centreon/broker/neb/internal.hh"
  "${INC_DIR}/com/centreon/broker/neb/log_entry.hh"
  "${INC_DIR}/com/centreon/broker/neb/module.hh"
  "${INC_DIR}/com/centreon/broker/neb/service.hh"
  "${INC_DIR}/com/centreon/broker/neb/service_check.hh"
  "${INC_DIR}/com/centreon/broker/neb/service_dependency.hh"
  "${INC_DIR}/com/centreon/broker/neb/service_group.hh"
  "${INC_DIR}/com/centreon/broker/neb/service_group_member.hh"
  "${INC_DIR}/com/centreon/broker/neb/service_status.hh"
  "${INC_DIR}/com/centreon/broker/neb/status.hh"
)

# Static library.
add_library("nebbase" STATIC ${NEB_SOURCES})
include(CheckCXXCompilerFlag)
check_cxx_compiler_flag("-fPIC" COMPILER_HAS_FPIC)
if (COMPILER_HAS_FPIC)
  get_property(NEBBASE_CXXFLAGS
    TARGET "nebbase"
    PROPERTY COMPILE_FLAGS)
  if (NEBBASE_CXXFLAGS)
    set(NEBBASE_CXXFLAGS "${NEBBASE_CXXFLAGS} -fPIC")
  else ()
    set(NEBBASE_CXXFLAGS "-fPIC")
  endif ()
  set_property(TARGET "nebbase"
    PROPERTY COMPILE_FLAGS "${NEBBASE_CXXFLAGS}")
endif ()

# Centreon Broker module.
set(NEB "10-neb")
set(NEB "${NEB}" PARENT_SCOPE)
add_library("${NEB}" SHARED
  # Main source.
  "${SRC_DIR}/broker.cc"
  "${SRC_DIR}/downtime_scheduler.cc"
  "${SRC_DIR}/node_cache.cc"
  "${SRC_DIR}/node_events_connector.cc"
  "${SRC_DIR}/node_events_factory.cc"
  "${SRC_DIR}/node_events_stream.cc"
  "${SRC_DIR}/node_id.cc"
  "${SRC_DIR}/timeperiod_serializable.cc"
  "${SRC_DIR}/downtime_serializable.cc"
  "${SRC_DIR}/downtime_map.cc"

  # Inc
  "${INC_DIR}/com/centreon/broker/neb/downtime_scheduler.hh"
  "${INC_DIR}/com/centreon/broker/neb/node_cache.hh"
  "${INC_DIR}/com/centreon/broker/neb/node_events_connector.hh"
  "${INC_DIR}/com/centreon/broker/neb/node_events_factory.hh"
  "${INC_DIR}/com/centreon/broker/neb/node_events_stream.hh"
  "${INC_DIR}/com/centreon/broker/neb/node_id.hh"
  "${INC_DIR}/com/centreon/broker/neb/timeperiod_serializable.hh"
  "${INC_DIR}/com/centreon/broker/neb/downtime_serializable.hh"
  "${INC_DIR}/com/centreon/broker/neb/downtime_map.hh"
)
if (CMAKE_COMPILER_IS_GNUCXX)
  # Flags needed to include all symbols in binary.
  target_link_libraries("${NEB}"
    "-Wl,--whole-archive" "nebbase" "-Wl,--no-whole-archive")
else ()
  target_link_libraries("${NEB}" "nebbase")
endif ()
target_link_libraries("${NEB}" ${QT_LIBRARIES})
set_target_properties("${NEB}" PROPERTIES PREFIX "")
install(TARGETS "${NEB}"
  LIBRARY DESTINATION "${PREFIX_MODULES}"
)

# Centreon Engine/Nagios module.
set(CBMOD "cbmod")
add_library("${CBMOD}" SHARED
  # Sources.
  "${PROJECT_SOURCE_DIR}/core/src/config/applier/init.cc"
  "${PROJECT_SOURCE_DIR}/core/src/config/applier/logger.cc"
  "${SRC_DIR}/callback.cc"
  "${SRC_DIR}/callbacks.cc"
  "${SRC_DIR}/initial.cc"
  "${SRC_DIR}/internal.cc"
  "${SRC_DIR}/monitoring_logger.cc"
  "${SRC_DIR}/neb.cc"
  "${SRC_DIR}/set_log_data.cc"
  "${SRC_DIR}/engcmd/factory.cc"
  "${SRC_DIR}/engcmd/endpoint.cc"
  "${SRC_DIR}/engcmd/engine_command.cc"
  "${SRC_DIR}/engcmd/internal.cc"
  "${SRC_DIR}/statistics/active_host_execution_time.cc"
  "${SRC_DIR}/statistics/active_host_latency.cc"
  "${SRC_DIR}/statistics/active_host_state_change.cc"
  "${SRC_DIR}/statistics/active_hosts_last.cc"
  "${SRC_DIR}/statistics/active_service_execution_time.cc"
  "${SRC_DIR}/statistics/active_service_latency.cc"
  "${SRC_DIR}/statistics/active_service_state_change.cc"
  "${SRC_DIR}/statistics/active_services_last.cc"
  "${SRC_DIR}/statistics/command_buffers.cc"
  "${SRC_DIR}/statistics/generator.cc"
  "${SRC_DIR}/statistics/hosts.cc"
  "${SRC_DIR}/statistics/hosts_actively_checked.cc"
  "${SRC_DIR}/statistics/hosts_checked.cc"
  "${SRC_DIR}/statistics/hosts_flapping.cc"
  "${SRC_DIR}/statistics/hosts_scheduled.cc"
  "${SRC_DIR}/statistics/passive_host_latency.cc"
  "${SRC_DIR}/statistics/passive_host_state_change.cc"
  "${SRC_DIR}/statistics/passive_hosts_last.cc"
  "${SRC_DIR}/statistics/passive_service_latency.cc"
  "${SRC_DIR}/statistics/passive_service_state_change.cc"
  "${SRC_DIR}/statistics/passive_services_last.cc"
  "${SRC_DIR}/statistics/plugin.cc"
  "${SRC_DIR}/statistics/services.cc"
  "${SRC_DIR}/statistics/services_actively_checked.cc"
  "${SRC_DIR}/statistics/services_checked.cc"
  "${SRC_DIR}/statistics/services_flapping.cc"
  "${SRC_DIR}/statistics/services_scheduled.cc"
  "${SRC_DIR}/statistics/total_host_state_change.cc"
  "${SRC_DIR}/statistics/total_hosts.cc"
  "${SRC_DIR}/statistics/total_service_state_change.cc"
  "${SRC_DIR}/statistics/total_services.cc"
  # Headers.
  "${INC_DIR}/com/centreon/broker/neb/callback.hh"
  "${INC_DIR}/com/centreon/broker/neb/callbacks.hh"
  "${INC_DIR}/com/centreon/broker/neb/initial.hh"
  "${INC_DIR}/com/centreon/broker/neb/internal.hh"
  "${INC_DIR}/com/centreon/broker/neb/monitoring_logger.hh"
  "${INC_DIR}/com/centreon/broker/neb/set_log_data.hh"
  "${INC_DIR}/com/centreon/broker/neb/engcmd/factory.hh"
  "${INC_DIR}/com/centreon/broker/neb/engcmd/endpoint.hh"
  "${INC_DIR}/com/centreon/broker/neb/engcmd/engine_command.hh"
  "${INC_DIR}/com/centreon/broker/neb/statistics/active_host_execution_time.hh"
  "${INC_DIR}/com/centreon/broker/neb/statistics/active_host_latency.hh"
  "${INC_DIR}/com/centreon/broker/neb/statistics/active_host_state_change.hh"
  "${INC_DIR}/com/centreon/broker/neb/statistics/active_hosts_last.hh"
  "${INC_DIR}/com/centreon/broker/neb/statistics/active_service_execution_time.hh"
  "${INC_DIR}/com/centreon/broker/neb/statistics/active_service_latency.hh"
  "${INC_DIR}/com/centreon/broker/neb/statistics/active_service_state_change.hh"
  "${INC_DIR}/com/centreon/broker/neb/statistics/active_services_last.hh"
  "${INC_DIR}/com/centreon/broker/neb/statistics/command_buffers.hh"
  "${INC_DIR}/com/centreon/broker/neb/statistics/compute_value.hh"
  "${INC_DIR}/com/centreon/broker/neb/statistics/generator.hh"
  "${INC_DIR}/com/centreon/broker/neb/statistics/hosts.hh"
  "${INC_DIR}/com/centreon/broker/neb/statistics/hosts_actively_checked.hh"
  "${INC_DIR}/com/centreon/broker/neb/statistics/hosts_checked.hh"
  "${INC_DIR}/com/centreon/broker/neb/statistics/hosts_flapping.hh"
  "${INC_DIR}/com/centreon/broker/neb/statistics/hosts_scheduled.hh"
  "${INC_DIR}/com/centreon/broker/neb/statistics/passive_host_latency.hh"
  "${INC_DIR}/com/centreon/broker/neb/statistics/passive_host_state_change.hh"
  "${INC_DIR}/com/centreon/broker/neb/statistics/passive_hosts_last.hh"
  "${INC_DIR}/com/centreon/broker/neb/statistics/passive_service_latency.hh"
  "${INC_DIR}/com/centreon/broker/neb/statistics/passive_service_state_change.hh"
  "${INC_DIR}/com/centreon/broker/neb/statistics/passive_services_last.hh"
  "${INC_DIR}/com/centreon/broker/neb/statistics/plugin.hh"
  "${INC_DIR}/com/centreon/broker/neb/statistics/services.hh"
  "${INC_DIR}/com/centreon/broker/neb/statistics/services_actively_checked.hh"
  "${INC_DIR}/com/centreon/broker/neb/statistics/services_checked.hh"
  "${INC_DIR}/com/centreon/broker/neb/statistics/services_flapping.hh"
  "${INC_DIR}/com/centreon/broker/neb/statistics/services_scheduled.hh"
  "${INC_DIR}/com/centreon/broker/neb/statistics/total_host_state_change.hh"
  "${INC_DIR}/com/centreon/broker/neb/statistics/total_hosts.hh"
  "${INC_DIR}/com/centreon/broker/neb/statistics/total_service_state_change.hh"
  "${INC_DIR}/com/centreon/broker/neb/statistics/total_services.hh"
)
get_property(CBMOD_DEFINES
  TARGET "${CBMOD}"
  PROPERTY COMPILE_DEFINITIONS)
list(APPEND CBMOD_DEFINES CBMOD)
set_property(TARGET "${CBMOD}"
  PROPERTY COMPILE_DEFINITIONS "${CBMOD_DEFINES}")
if (CMAKE_COMPILER_IS_GNUCXX)
  # Flags needed to include all symbols in shared library.
  target_link_libraries("${CBMOD}"
    "-Wl,--whole-archive" "nebbase" "rokerbase" "-Wl,--no-whole-archive")
else ()
  target_link_libraries("${CBMOD}" "nebbase" "rokerbase")
endif ()
set_target_properties("${CBMOD}" PROPERTIES PREFIX "")

# Unit tests.
if (0) # WITH_TESTING)
  include_directories("${PROJECT_SOURCE_DIR}/neb")
  include_directories("${PROJECT_SOURCE_DIR}/correlation/inc")
  include_directories("${PROJECT_SOURCE_DIR}/dumper/inc")
  set(TEST_LIBRARIES "${NEB}" "rokerbase" "roker" "rokerbase")
  # Custom Variable tests.
  #   Default constructor.
  set(TEST_NAME "neb_custom_variable_ctor_default")
  add_executable("${TEST_NAME}"
    "${TEST_DIR}/custom_variable/ctor_default.cc")
  target_link_libraries("${TEST_NAME}" ${TEST_LIBRARIES})
  add_test("${TEST_NAME}" "${TEST_NAME}")
  #   Copy constructor.
  set(TEST_NAME "neb_custom_variable_ctor_copy")
  add_executable("${TEST_NAME}"
    "${TEST_DIR}/custom_variable/ctor_copy.cc")
  target_link_libraries("${TEST_NAME}" ${TEST_LIBRARIES})
  add_test("${TEST_NAME}" "${TEST_NAME}")
  #   Assignment operator.
  set(TEST_NAME "neb_custom_variable_assignment")
  add_executable("${TEST_NAME}"

=== build/notification/CMakeLists.txt ===
##
## Copyright 2014-2015 Centreon
##
## Licensed under the Apache License, Version 2.0 (the "License");
## you may not use this file except in compliance with the License.
## You may obtain a copy of the License at
##
##     http://www.apache.org/licenses/LICENSE-2.0
##
## Unless required by applicable law or agreed to in writing, software
## distributed under the License is distributed on an "AS IS" BASIS,
## WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
## See the License for the specific language governing permissions and
## limitations under the License.
##
## For more information : contact@centreon.com
##

# Global options.
set(INC_DIR "${PROJECT_SOURCE_DIR}/notification/inc/com/centreon/broker/notification")
set(SRC_DIR "${PROJECT_SOURCE_DIR}/notification/src")
include_directories("${PROJECT_SOURCE_DIR}/notification/inc")
include_directories("${PROJECT_SOURCE_DIR}/correlation/inc")
include_directories("${PROJECT_SOURCE_DIR}/dumper/inc")
include_directories("${PROJECT_SOURCE_DIR}/neb/inc")
include_directories("${PROJECT_SOURCE_DIR}/file/inc")
include_directories("${PROJECT_SOURCE_DIR}/bbdo/inc")
include_directories("${PROJECT_SOURCE_DIR}/compression/inc")

# Some files must be processed by Qt's moc.
unset(QT_WRAPPED_SOURCES)
qt4_wrap_cpp(QT_WRAPPED_SOURCES
  "${INC_DIR}/process_manager.hh"
  "${INC_DIR}/process.hh")

# Notification module.
set(NOTIFICATION "40-notification")
set(NOTIFICATION "${NOTIFICATION}" PARENT_SCOPE)
add_library("${NOTIFICATION}" SHARED
  ${QT_WRAPPED_SOURCES}
  # Sources.
  "${SRC_DIR}/action.cc"
  "${SRC_DIR}/factory.cc"
  "${SRC_DIR}/macro_context.cc"
  "${SRC_DIR}/macro_generator.cc"
  "${SRC_DIR}/macro_getters.cc"
  "${SRC_DIR}/main.cc"
  "${SRC_DIR}/node_cache.cc"
  "${SRC_DIR}/notification_scheduler.cc"
  "${SRC_DIR}/process.cc"
  "${SRC_DIR}/process_manager.cc"
  "${SRC_DIR}/run_queue.cc"
  "${SRC_DIR}/state.cc"
  "${SRC_DIR}/stream.cc"
  "${SRC_DIR}/connector.cc"
  "${SRC_DIR}/objects/command.cc"
  "${SRC_DIR}/objects/contact.cc"
  "${SRC_DIR}/objects/dependency.cc"
  "${SRC_DIR}/objects/node.cc"
  "${SRC_DIR}/objects/node_id.cc"
  "${SRC_DIR}/objects/defines.cc"
  "${SRC_DIR}/objects/notification_method.cc"
  "${SRC_DIR}/objects/notification_rule.cc"
  "${SRC_DIR}/loaders/contact_loader.cc"
  "${SRC_DIR}/loaders/dependency_loader.cc"
  "${SRC_DIR}/loaders/node_loader.cc"
  "${SRC_DIR}/loaders/timeperiod_loader.cc"
  "${SRC_DIR}/loaders/command_loader.cc"
  "${SRC_DIR}/loaders/notification_method_loader.cc"
  "${SRC_DIR}/loaders/notification_rule_loader.cc"
  "${SRC_DIR}/loaders/macro_loader.cc"
  "${SRC_DIR}/builders/node_set_builder.cc"
  "${SRC_DIR}/builders/composed_contact_builder.cc"
  "${SRC_DIR}/builders/contact_by_id_builder.cc"
  "${SRC_DIR}/builders/composed_dependency_builder.cc"
  "${SRC_DIR}/builders/composed_node_builder.cc"
  "${SRC_DIR}/builders/composed_timeperiod_builder.cc"
  "${SRC_DIR}/builders/composed_command_builder.cc"
  "${SRC_DIR}/builders/composed_notification_method_builder.cc"
  "${SRC_DIR}/builders/composed_notification_rule_builder.cc"
  "${SRC_DIR}/builders/dependency_by_node_id_builder.cc"
  "${SRC_DIR}/builders/timeperiod_by_id_builder.cc"
  "${SRC_DIR}/builders/timeperiod_linker.cc"
  "${SRC_DIR}/builders/command_by_id_builder.cc"
  "${SRC_DIR}/builders/node_by_node_id_builder.cc"
  "${SRC_DIR}/builders/global_macro_builder.cc"
  "${SRC_DIR}/builders/notification_method_by_id_builder.cc"
  "${SRC_DIR}/builders/notification_rule_by_node_builder.cc"
  "${SRC_DIR}/builders/notification_rule_by_id_builder.cc"
  "${SRC_DIR}/utilities/data_loggers.cc"
  "${SRC_DIR}/utilities/qhash_func.cc"
  "${SRC_DIR}/utilities/get_datetime_string.cc"
  # Headers.
  "${INC_DIR}/action.hh"
  "${INC_DIR}/factory.hh"
  "${INC_DIR}/macro_context.hh"
  "${INC_DIR}/macro_generator.hh"
  "${INC_DIR}/macro_getters.hh"
  "${INC_DIR}/node_cache.hh"
  "${INC_DIR}/notification_scheduler.hh"
  "${INC_DIR}/process.hh"
  "${INC_DIR}/process_manager.hh"
  "${INC_DIR}/run_queue.hh"
  "${INC_DIR}/state.hh"
  "${INC_DIR}/stream.hh"
  "${INC_DIR}/connector.hh"
  "${INC_DIR}/objects/command.hh"
  "${INC_DIR}/objects/contact.hh"
  "${INC_DIR}/objects/dependency.hh"
  "${INC_DIR}/objects/node.hh"
  "${INC_DIR}/objects/node_id.hh"
  "${INC_DIR}/objects/defines.hh"
  "${INC_DIR}/objects/notification_method.hh"
  "${INC_DIR}/objects/notification_rule.hh"
  "${INC_DIR}/loaders/command_loader.hh"
  "${INC_DIR}/loaders/contact_loader.hh"
  "${INC_DIR}/loaders/dependency_loader.hh"
  "${INC_DIR}/loaders/node_loader.hh"
  "${INC_DIR}/loaders/timeperiod_loader.hh"
  "${INC_DIR}/loaders/notification_method_loader.hh"
  "${INC_DIR}/loaders/notification_rule_loader.hh"
  "${INC_DIR}/loaders/macro_loader.hh"
  "${INC_DIR}/builders/timeperiod_builder.hh"
  "${INC_DIR}/builders/command_builder.hh"
  "${INC_DIR}/builders/contact_builder.hh"
  "${INC_DIR}/builders/dependency_builder.hh"
  "${INC_DIR}/builders/node_builder.hh"
  "${INC_DIR}/builders/node_set_builder.hh"
  "${INC_DIR}/builders/composed_contact_builder.hh"
  "${INC_DIR}/builders/contact_by_id_builder.hh"
  "${INC_DIR}/builders/composed_builder.hh"
  "${INC_DIR}/builders/composed_dependency_builder.hh"
  "${INC_DIR}/builders/composed_node_builder.hh"
  "${INC_DIR}/builders/composed_timeperiod_builder.hh"
  "${INC_DIR}/builders/composed_command_builder.hh"
  "${INC_DIR}/builders/composed_notification_method_builder.hh"
  "${INC_DIR}/builders/composed_notification_rule_builder.hh"
  "${INC_DIR}/builders/dependency_by_node_id_builder.hh"
  "${INC_DIR}/builders/timeperiod_by_id_builder.hh"
  "${INC_DIR}/builders/timeperiod_linker.hh"
  "${INC_DIR}/builders/command_by_id_builder.hh"
  "${INC_DIR}/builders/macro_builder.hh"
  "${INC_DIR}/builders/global_macro_builder.hh"
  "${INC_DIR}/builders/node_by_node_id_builder.hh"
  "${INC_DIR}/builders/notification_method_builder.hh"
  "${INC_DIR}/builders/notification_method_by_id_builder.hh"
  "${INC_DIR}/builders/notification_rule_builder.hh"
  "${INC_DIR}/builders/notification_rule_by_node_builder.hh"
  "${INC_DIR}/builders/notification_rule_by_id_builder.hh"
  "${INC_DIR}/utilities/ptr_typedef.hh"
  "${INC_DIR}/utilities/data_loggers.hh"
  "${INC_DIR}/utilities/qhash_func.hh"
  "${INC_DIR}/utilities/get_datetime_string.hh"
)
target_link_libraries("${NOTIFICATION}" ${QT_LIBRARIES})
set_target_properties("${NOTIFICATION}" PROPERTIES PREFIX "")

# Install rule.
install(TARGETS "${NOTIFICATION}"
  LIBRARY DESTINATION "${PREFIX_MODULES}"
)

=== build/rrd/CMakeLists.txt ===
##
## Copyright 2011-2013 Centreon
##
## Licensed under the Apache License, Version 2.0 (the "License");
## you may not use this file except in compliance with the License.
## You may obtain a copy of the License at
##
##     http://www.apache.org/licenses/LICENSE-2.0
##
## Unless required by applicable law or agreed to in writing, software
## distributed under the License is distributed on an "AS IS" BASIS,
## WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
## See the License for the specific language governing permissions and
## limitations under the License.
##
## For more information : contact@centreon.com
##

# Global options.
set(INC_DIR "${PROJECT_SOURCE_DIR}/rrd/inc")
set(SRC_DIR "${PROJECT_SOURCE_DIR}/rrd/src")
set(TEST_DIR "${PROJECT_SOURCE_DIR}/rrd/test")
include_directories("${INC_DIR}")
include_directories("${PROJECT_SOURCE_DIR}/storage/inc")

# Find librrd.
include(FindPkgConfig)
if (PKG_CONFIG_FOUND)
  pkg_check_modules(LIBRRD REQUIRED "librrd")
  if (LIBRRD_INCLUDE_DIRS)
    include_directories("${LIBRRD_INCLUDE_DIRS}")
    set(LIBRRD_INCLUDE_DIRS "${LIBRRD_INCLUDE_DIRS}" PARENT_SCOPE)
  endif ()
else ()
  # Find rrd.h
  find_path(LIBRRD_INCLUDE_DIR "rrd.h")
  if (NOT LIBRRD_INCLUDE_DIR)
    message(FATAL_ERROR "Could not find librrd's headers.")
  endif ()
  include_directories("${LIBRRD_INCLUDE_DIR}")
  set(LIBRRD_INCLUDE_DIRS "${LIBRRD_INCLUDE_DIR}" PARENT_SCOPE)

  # Find librrd.
  find_library(LIBRRD_LDFLAGS "rrd")
  if (NOT LIBRRD_LDFLAGS)
    message(FATAL_ERROR "Could not find librrd's library.")
  endif ()
  set(LIBRRD_LDFLAGS "${LIBRRD_LDFLAGS}" PARENT_SCOPE)
endif ()

# RRD module.
set(RRD "70-rrd")
set(RRD "${RRD}" PARENT_SCOPE)
add_library("${RRD}" SHARED
  # Sources.
  "${SRC_DIR}/backend.cc"
  "${SRC_DIR}/cached.cc"
  "${SRC_DIR}/connector.cc"
  "${SRC_DIR}/creator.cc"
  "${SRC_DIR}/exceptions/open.cc"
  "${SRC_DIR}/exceptions/update.cc"
  "${SRC_DIR}/factory.cc"
  "${SRC_DIR}/lib.cc"
  "${SRC_DIR}/main.cc"
  "${SRC_DIR}/output.cc"
  # Headers.
  "${INC_DIR}/com/centreon/broker/rrd/backend.hh"
  "${INC_DIR}/com/centreon/broker/rrd/cached.hh"
  "${INC_DIR}/com/centreon/broker/rrd/connector.hh"
  "${INC_DIR}/com/centreon/broker/rrd/creator.hh"
  "${INC_DIR}/com/centreon/broker/rrd/exceptions/open.hh"
  "${INC_DIR}/com/centreon/broker/rrd/exceptions/update.hh"
  "${INC_DIR}/com/centreon/broker/rrd/factory.hh"
  "${INC_DIR}/com/centreon/broker/rrd/lib.hh"
  "${INC_DIR}/com/centreon/broker/rrd/output.hh"
)
target_link_libraries("${RRD}" ${QT_LIBRARIES})
set_target_properties("${RRD}" PROPERTIES PREFIX "")

# Compile with librrd flags.
if (LIBRRD_CFLAGS)
  get_source_file_property(RRD_SOURCE_CXXFLAGS "${SRC_DIR}/lib.cc" COMPILE_FLAGS)
  if (LIBRRD_SOURCE_CXXFLAGS)
    set_source_files_properties("${SRC_DIR}/lib.cc" PROPERTIES
      COMPILE_FLAGS "${RRD_SOURCE_CXXFLAGS} ${LIBRRD_CFLAGS}")
  else ()
    set_source_files_properties("${SRC_DIR}/lib.cc" PROPERTIES
      COMPILE_FLAGS "${LIBRRD_CFLAGS}")
  endif ()
endif ()
target_link_libraries("${RRD}" ${LIBRRD_LDFLAGS})

if (0) # WITH_TESTING)
  set(TEST_LIBRARIES "${RRD}" "10-neb" "20-storage" "roker" "rokerbase" "roker")

  # Open exception tests.
  #   Throw.
  set(TEST_NAME "rrd_exceptions_open_throw")
  add_executable("${TEST_NAME}"
    "${TEST_DIR}/exceptions/open/throw.cc")
  target_link_libraries("${TEST_NAME}" ${TEST_LIBRARIES})
  add_test("${TEST_NAME}" "${TEST_NAME}")
  #   Rethrow.
  set(TEST_NAME "rrd_exceptions_open_rethrow")
  add_executable("${TEST_NAME}"
    "${TEST_DIR}/exceptions/open/rethrow.cc")
  target_link_libraries("${TEST_NAME}" ${TEST_LIBRARIES})
  add_test("${TEST_NAME}" "${TEST_NAME}")
  #   Clone.
  set(TEST_NAME "rrd_exceptions_open_clone")
  add_executable("${TEST_NAME}"
    "${TEST_DIR}/exceptions/open/clone.cc")
  target_link_libraries("${TEST_NAME}" ${TEST_LIBRARIES})
  add_test("${TEST_NAME}" "${TEST_NAME}")
  # Update exception tests.
  #   Throw.
  set(TEST_NAME "rrd_exceptions_update_throw")
  add_executable("${TEST_NAME}"
    "${TEST_DIR}/exceptions/update/throw.cc")
  target_link_libraries("${TEST_NAME}" ${TEST_LIBRARIES})
  add_test("${TEST_NAME}" "${TEST_NAME}")
  #   Rethrow.
  set(TEST_NAME "rrd_exceptions_update_rethrow")
  add_executable("${TEST_NAME}"
    "${TEST_DIR}/exceptions/update/rethrow.cc")
  target_link_libraries("${TEST_NAME}" ${TEST_LIBRARIES})
  add_test("${TEST_NAME}" "${TEST_NAME}")
  #   Clone.
  set(TEST_NAME "rrd_exceptions_update_clone")
  add_executable("${TEST_NAME}"
    "${TEST_DIR}/exceptions/update/clone.cc")
  target_link_libraries("${TEST_NAME}" ${TEST_LIBRARIES})
  add_test("${TEST_NAME}" "${TEST_NAME}")
  # RRD lib tests.
  #   File creation.
  set(TEST_NAME "rrd_lib_create")
  add_executable("${TEST_NAME}"
    "${TEST_DIR}/lib/create.cc")
  target_link_libraries("${TEST_NAME}" ${TEST_LIBRARIES})
  add_test("${TEST_NAME}" "${TEST_NAME}")
  #   File remove.
  set(TEST_NAME "rrd_lib_remove")
  add_executable("${TEST_NAME}"
    "${TEST_DIR}/lib/remove.cc")
  target_link_libraries("${TEST_NAME}" ${TEST_LIBRARIES})
  add_test("${TEST_NAME}" "${TEST_NAME}")
endif ()

# Install rule.
install(TARGETS "${RRD}"
  LIBRARY DESTINATION "${PREFIX_MODULES}"
)

=== build/sql/CMakeLists.txt ===
##
## Copyright 2011-2015 Centreon
##
## Licensed under the Apache License, Version 2.0 (the "License");
## you may not use this file except in compliance with the License.
## You may obtain a copy of the License at
##
##     http://www.apache.org/licenses/LICENSE-2.0
##
## Unless required by applicable law or agreed to in writing, software
## distributed under the License is distributed on an "AS IS" BASIS,
## WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
## See the License for the specific language governing permissions and
## limitations under the License.
##
## For more information : contact@centreon.com
##

# Global options.
set(INC_DIR "${PROJECT_SOURCE_DIR}/sql/inc")
set(SRC_DIR "${PROJECT_SOURCE_DIR}/sql/src")
include_directories("${INC_DIR}")
include_directories("${PROJECT_SOURCE_DIR}/correlation/inc")
include_directories("${PROJECT_SOURCE_DIR}/neb/inc")

# SQL module.
set(SQL "80-sql")
set(SQL "${SQL}" PARENT_SCOPE)
add_library("${SQL}" SHARED
  # Sources.
  "${SRC_DIR}/cleanup.cc"
  "${SRC_DIR}/connector.cc"
  "${SRC_DIR}/factory.cc"
  "${SRC_DIR}/main.cc"
  "${SRC_DIR}/stream.cc"
  "${SRC_DIR}/stored_timestamp.cc"
  # Headers.
  "${INC_DIR}/com/centreon/broker/sql/cleanup.hh"
  "${INC_DIR}/com/centreon/broker/sql/connector.hh"
  "${INC_DIR}/com/centreon/broker/sql/factory.hh"
  "${INC_DIR}/com/centreon/broker/sql/stream.hh"
  "${INC_DIR}/com/centreon/broker/sql/stored_timestamp.hh"
)
target_link_libraries("${SQL}" ${QT_LIBRARIES})
set_target_properties("${SQL}" PROPERTIES PREFIX "")

# Install rule.
install(TARGETS "${SQL}"
  LIBRARY DESTINATION "${PREFIX_MODULES}"
)

=== debian/changelog ===
centreon-broker (18.10.0-4) unstable; urgency=medium

  * Add missing attributions in d/copyright (Closes: #917299)

 -- Sebastien Delafond <seb@debian.org>  Wed, 26 Dec 2018 13:12:15 +0100

centreon-broker (18.10.0-3) unstable; urgency=medium

  * Give centreon-engine permission to write in /var/log/centreon-broker
  * Explicitely depend on libqt4-sql-mysql

 -- Sebastien Delafond <seb@debian.org>  Fri, 21 Dec 2018 11:19:10 +0100

centreon-broker (18.10.0-2) unstable; urgency=medium

  * Update d/copyright
  * Change rights on /var/{log,lib}/centreon-broker

 -- Sebastien Delafond <seb@debian.org>  Wed, 19 Dec 2018 09:29:18 +0100

centreon-broker (18.10.0-1) unstable; urgency=medium

  * Initial release (Closes: #913898)

 -- Sebastien Delafond <seb@debian.org>  Mon, 12 Nov 2018 15:56:47 +0100

=== debian/control ===
Source: centreon-broker
Section: net
Priority: optional
Maintainer: Freexian Packaging Team <team+freexian@tracker.debian.org>
Uploaders: Sebastien Delafond <seb@debian.org>
Build-Depends: debhelper (>= 11), cmake, libcentreon-clib, libqt4-dev, libqt4-opengl-dev, zlib1g-dev, pkg-config, librrd-dev, liblua5.3-dev, libgnutls28-dev
Standards-Version: 4.2.1
Homepage: https://github.com/centreon/centreon-broker
Vcs-Browser: https://salsa.debian.org/centreon-team/centreon-broker
Vcs-Git: https://salsa.debian.org/centreon-team/centreon-broker.git

Package: centreon-broker
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, centreon-engine, rrdtool, adduser, libqt4-sql-mysql
Description: Network, system, applicative supervision and monitoring - broker
 Centreon is a modular and flexible platform for network, system and
 applicative supervision and monitoring.
 .
  * monitoring of network services
  * monitoring of host resources
  * simple plugin design that allows users to easily develop their own
    service checks
  * parallelized service checks
  * ability to define network hierarchies
  * contact notifications when service or host problems occur and get
    resolved (via email, page, or user-defined method)
  * ability to define event handlers to be run during service or host
    events for proactive problem resolution
  * automatic log file rotation
  * support for implementing redundant monitoring hosts
 .
 This package contains the broker daemon.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk

export DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
CFLAGS+=$(CPPFLAGS)
# see https://github.com/centreon/centreon-broker/issues/139
CXXFLAGS+=$(CPPFLAGS) -std=c++98 -fpermissive

export CMAKE_OPTIONS := \
  -DCMAKE_C_COMPILER="$(CC)" \
  -DCMAKE_CXX_COMPILER="$(CXX)" \
  -DCMAKE_CXX_FLAGS="$(CXXFLAGS)" \
  -DCMAKE_SHARED_LINKER_FLAGS_RELEASE="$(LDFLAGS)" \
  -DWITH_PREFIX=/usr \
  -DWITH_PREFIX_BIN=/usr/sbin \
  -DWITH_PREFIX_CONF=/etc/centreon-broker \
  -DWITH_PREFIX_LIB=/usr/lib/centreon-broker \
  -DWITH_PREFIX_VAR=/var/lib/centreon-broker \
  -DWITH_LOGROTATE_SCRIPT=1 \
  -DWITH_VAR_DIR=/var/log/centreon-broker \
  -DWITH_PREFIX_MODULES=/usr/lib/centreon-broker/modules \
  -DWITH_PKGCONFIG_SCRIPT=1 \
  -DWITH_PKGCONFIG_DIR=/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig \
  -DWITH_DAEMONS='central-broker;central-rrd' \
  -DWITH_STARTUP_SCRIPT=systemd \
  -DWITH_STARTUP_DIR=/lib/systemd/system \
  -DWITH_USER=centreon-broker \
  -DWITH_GROUP=centreon-broker \
  -DWITH_CONFIG_FILES=1

%:
	dh $@ --sourcedirectory=build

override_dh_auto_configure:
	dh_auto_configure --sourcedirectory=build -- $(CMAKE_OPTIONS)
